'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var immer = require('immer');

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n["default"] = e;
  return n;
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var runtime = {exports: {}};

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

(function (module) {
var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = GeneratorFunctionPrototype;
  define(Gp, "constructor", GeneratorFunctionPrototype);
  define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  });
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  define(Gp, iteratorSymbol, function() {
    return this;
  });

  define(Gp, "toString", function() {
    return "[object Generator]";
  });

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
  module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, in modern engines
  // we can explicitly access globalThis. In older engines we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}
}(runtime));

var _regeneratorRuntime = runtime.exports;

function cov_20wqqco38b() {
  var path = "/home/vinoth/projects/react-sketch-canvas/src/Paths/index.tsx";
  var hash = "39426ce4c91e7b49cfd8b54c9eb7f9ff18d17d03";
  var global = new Function("return this")();
  var gcv = "__coverage__";
  var coverageData = {
    path: "/home/vinoth/projects/react-sketch-canvas/src/Paths/index.tsx",
    statementMap: {
      "0": {
        start: {
          line: 5,
          column: 23
        },
        end: {
          line: 13,
          column: 1
        }
      },
      "1": {
        start: {
          line: 6,
          column: 4
        },
        end: {
          line: 10,
          column: 5
        }
      },
      "2": {
        start: {
          line: 7,
          column: 25
        },
        end: {
          line: 7,
          column: 33
        }
      },
      "3": {
        start: {
          line: 8,
          column: 23
        },
        end: {
          line: 8,
          column: 38
        }
      },
      "4": {
        start: {
          line: 9,
          column: 8
        },
        end: {
          line: 9,
          column: 133
        }
      },
      "5": {
        start: {
          line: 11,
          column: 14
        },
        end: {
          line: 11,
          column: 124
        }
      },
      "6": {
        start: {
          line: 11,
          column: 49
        },
        end: {
          line: 11,
          column: 119
        }
      },
      "7": {
        start: {
          line: 12,
          column: 4
        },
        end: {
          line: 12,
          column: 153
        }
      },
      "8": {
        start: {
          line: 14,
          column: 20
        },
        end: {
          line: 21,
          column: 1
        }
      },
      "9": {
        start: {
          line: 15,
          column: 20
        },
        end: {
          line: 15,
          column: 39
        }
      },
      "10": {
        start: {
          line: 16,
          column: 20
        },
        end: {
          line: 16,
          column: 39
        }
      },
      "11": {
        start: {
          line: 17,
          column: 4
        },
        end: {
          line: 20,
          column: 6
        }
      },
      "12": {
        start: {
          line: 22,
          column: 21
        },
        end: {
          line: 33,
          column: 1
        }
      },
      "13": {
        start: {
          line: 23,
          column: 49
        },
        end: {
          line: 23,
          column: 62
        }
      },
      "14": {
        start: {
          line: 24,
          column: 14
        },
        end: {
          line: 24,
          column: 33
        }
      },
      "15": {
        start: {
          line: 25,
          column: 14
        },
        end: {
          line: 25,
          column: 29
        }
      },
      "16": {
        start: {
          line: 26,
          column: 22
        },
        end: {
          line: 26,
          column: 25
        }
      },
      "17": {
        start: {
          line: 27,
          column: 14
        },
        end: {
          line: 27,
          column: 24
        }
      },
      "18": {
        start: {
          line: 28,
          column: 18
        },
        end: {
          line: 28,
          column: 51
        }
      },
      "19": {
        start: {
          line: 29,
          column: 19
        },
        end: {
          line: 29,
          column: 39
        }
      },
      "20": {
        start: {
          line: 30,
          column: 14
        },
        end: {
          line: 30,
          column: 50
        }
      },
      "21": {
        start: {
          line: 31,
          column: 14
        },
        end: {
          line: 31,
          column: 50
        }
      },
      "22": {
        start: {
          line: 32,
          column: 4
        },
        end: {
          line: 32,
          column: 18
        }
      },
      "23": {
        start: {
          line: 34,
          column: 29
        },
        end: {
          line: 64,
          column: 1
        }
      },
      "24": {
        start: {
          line: 35,
          column: 15
        },
        end: {
          line: 35,
          column: 19
        }
      },
      "25": {
        start: {
          line: 36,
          column: 15
        },
        end: {
          line: 36,
          column: 19
        }
      },
      "26": {
        start: {
          line: 37,
          column: 4
        },
        end: {
          line: 56,
          column: 5
        }
      },
      "27": {
        start: {
          line: 39,
          column: 12
        },
        end: {
          line: 41,
          column: 15
        }
      },
      "28": {
        start: {
          line: 42,
          column: 12
        },
        end: {
          line: 42,
          column: 18
        }
      },
      "29": {
        start: {
          line: 44,
          column: 12
        },
        end: {
          line: 47,
          column: 15
        }
      },
      "30": {
        start: {
          line: 48,
          column: 12
        },
        end: {
          line: 48,
          column: 18
        }
      },
      "31": {
        start: {
          line: 50,
          column: 12
        },
        end: {
          line: 54,
          column: 15
        }
      },
      "32": {
        start: {
          line: 55,
          column: 12
        },
        end: {
          line: 55,
          column: 18
        }
      },
      "33": {
        start: {
          line: 57,
          column: 25
        },
        end: {
          line: 62,
          column: 6
        }
      },
      "34": {
        start: {
          line: 63,
          column: 4
        },
        end: {
          line: 63,
          column: 70
        }
      },
      "35": {
        start: {
          line: 65,
          column: 14
        },
        end: {
          line: 65,
          column: 277
        }
      },
      "36": {
        start: {
          line: 65,
          column: 30
        },
        end: {
          line: 65,
          column: 276
        }
      },
      "37": {
        start: {
          line: 65,
          column: 97
        },
        end: {
          line: 65,
          column: 273
        }
      }
    },
    fnMap: {
      "0": {
        name: "(anonymous_0)",
        decl: {
          start: {
            line: 5,
            column: 23
          },
          end: {
            line: 5,
            column: 24
          }
        },
        loc: {
          start: {
            line: 5,
            column: 94
          },
          end: {
            line: 13,
            column: 1
          }
        },
        line: 5
      },
      "1": {
        name: "(anonymous_1)",
        decl: {
          start: {
            line: 11,
            column: 27
          },
          end: {
            line: 11,
            column: 28
          }
        },
        loc: {
          start: {
            line: 11,
            column: 49
          },
          end: {
            line: 11,
            column: 119
          }
        },
        line: 11
      },
      "2": {
        name: "(anonymous_2)",
        decl: {
          start: {
            line: 14,
            column: 20
          },
          end: {
            line: 14,
            column: 21
          }
        },
        loc: {
          start: {
            line: 14,
            column: 40
          },
          end: {
            line: 21,
            column: 1
          }
        },
        line: 14
      },
      "3": {
        name: "(anonymous_3)",
        decl: {
          start: {
            line: 22,
            column: 21
          },
          end: {
            line: 22,
            column: 22
          }
        },
        loc: {
          start: {
            line: 22,
            column: 40
          },
          end: {
            line: 33,
            column: 1
          }
        },
        line: 22
      },
      "4": {
        name: "(anonymous_4)",
        decl: {
          start: {
            line: 34,
            column: 29
          },
          end: {
            line: 34,
            column: 30
          }
        },
        loc: {
          start: {
            line: 34,
            column: 46
          },
          end: {
            line: 64,
            column: 1
          }
        },
        line: 34
      },
      "5": {
        name: "(anonymous_5)",
        decl: {
          start: {
            line: 65,
            column: 14
          },
          end: {
            line: 65,
            column: 15
          }
        },
        loc: {
          start: {
            line: 65,
            column: 30
          },
          end: {
            line: 65,
            column: 276
          }
        },
        line: 65
      },
      "6": {
        name: "(anonymous_6)",
        decl: {
          start: {
            line: 65,
            column: 82
          },
          end: {
            line: 65,
            column: 83
          }
        },
        loc: {
          start: {
            line: 65,
            column: 97
          },
          end: {
            line: 65,
            column: 273
          }
        },
        line: 65
      }
    },
    branchMap: {
      "0": {
        loc: {
          start: {
            line: 5,
            column: 63
          },
          end: {
            line: 5,
            column: 86
          }
        },
        type: "default-arg",
        locations: [{
          start: {
            line: 5,
            column: 73
          },
          end: {
            line: 5,
            column: 86
          }
        }],
        line: 5
      },
      "1": {
        loc: {
          start: {
            line: 6,
            column: 4
          },
          end: {
            line: 10,
            column: 5
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 6,
            column: 4
          },
          end: {
            line: 10,
            column: 5
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 6
      },
      "2": {
        loc: {
          start: {
            line: 11,
            column: 49
          },
          end: {
            line: 11,
            column: 119
          }
        },
        type: "cond-expr",
        locations: [{
          start: {
            line: 11,
            column: 59
          },
          end: {
            line: 11,
            column: 84
          }
        }, {
          start: {
            line: 11,
            column: 87
          },
          end: {
            line: 11,
            column: 119
          }
        }],
        line: 11
      },
      "3": {
        loc: {
          start: {
            line: 24,
            column: 14
          },
          end: {
            line: 24,
            column: 33
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 24,
            column: 14
          },
          end: {
            line: 24,
            column: 22
          }
        }, {
          start: {
            line: 24,
            column: 26
          },
          end: {
            line: 24,
            column: 33
          }
        }],
        line: 24
      },
      "4": {
        loc: {
          start: {
            line: 25,
            column: 14
          },
          end: {
            line: 25,
            column: 29
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 25,
            column: 14
          },
          end: {
            line: 25,
            column: 18
          }
        }, {
          start: {
            line: 25,
            column: 22
          },
          end: {
            line: 25,
            column: 29
          }
        }],
        line: 25
      },
      "5": {
        loc: {
          start: {
            line: 28,
            column: 29
          },
          end: {
            line: 28,
            column: 50
          }
        },
        type: "cond-expr",
        locations: [{
          start: {
            line: 28,
            column: 39
          },
          end: {
            line: 28,
            column: 46
          }
        }, {
          start: {
            line: 28,
            column: 49
          },
          end: {
            line: 28,
            column: 50
          }
        }],
        line: 28
      },
      "6": {
        loc: {
          start: {
            line: 37,
            column: 4
          },
          end: {
            line: 56,
            column: 5
          }
        },
        type: "switch",
        locations: [{
          start: {
            line: 38,
            column: 8
          },
          end: {
            line: 42,
            column: 18
          }
        }, {
          start: {
            line: 43,
            column: 8
          },
          end: {
            line: 48,
            column: 18
          }
        }, {
          start: {
            line: 49,
            column: 8
          },
          end: {
            line: 55,
            column: 18
          }
        }],
        line: 37
      }
    },
    s: {
      "0": 0,
      "1": 0,
      "2": 0,
      "3": 0,
      "4": 0,
      "5": 0,
      "6": 0,
      "7": 0,
      "8": 0,
      "9": 0,
      "10": 0,
      "11": 0,
      "12": 0,
      "13": 0,
      "14": 0,
      "15": 0,
      "16": 0,
      "17": 0,
      "18": 0,
      "19": 0,
      "20": 0,
      "21": 0,
      "22": 0,
      "23": 0,
      "24": 0,
      "25": 0,
      "26": 0,
      "27": 0,
      "28": 0,
      "29": 0,
      "30": 0,
      "31": 0,
      "32": 0,
      "33": 0,
      "34": 0,
      "35": 0,
      "36": 0,
      "37": 0
    },
    f: {
      "0": 0,
      "1": 0,
      "2": 0,
      "3": 0,
      "4": 0,
      "5": 0,
      "6": 0
    },
    b: {
      "0": [0],
      "1": [0, 0],
      "2": [0, 0],
      "3": [0, 0],
      "4": [0, 0],
      "5": [0, 0],
      "6": [0, 0, 0]
    },
    _coverageSchema: "1a1c01bbd47fc00a2c39e90264f33305004495a9",
    hash: "39426ce4c91e7b49cfd8b54c9eb7f9ff18d17d03"
  };
  var coverage = global[gcv] || (global[gcv] = {});

  if (!coverage[path] || coverage[path].hash !== hash) {
    coverage[path] = coverageData;
  }

  var actualCoverage = coverage[path];
  {
    // @ts-ignore
    cov_20wqqco38b = function () {
      return actualCoverage;
    };
  }
  return actualCoverage;
}

cov_20wqqco38b();
/**
 * Generate SVG Path tag from the given points
 */

cov_20wqqco38b().s[0]++;
var SvgPath = function SvgPath(_ref) {
  var paths = _ref.paths,
      id = _ref.id,
      strokeWidth = _ref.strokeWidth,
      strokeColor = _ref.strokeColor,
      _ref$command = _ref.command,
      command = _ref$command === void 0 ? (cov_20wqqco38b().b[0][0]++, bezierCommand) : _ref$command;
  cov_20wqqco38b().f[0]++;
  cov_20wqqco38b().s[1]++;

  if (paths.length === 1) {
    cov_20wqqco38b().b[1][0]++;

    var _ref2 = (cov_20wqqco38b().s[2]++, paths[0]),
        x = _ref2.x,
        y = _ref2.y;

    var radius = (cov_20wqqco38b().s[3]++, strokeWidth / 2);
    cov_20wqqco38b().s[4]++;
    return React__namespace.createElement("circle", {
      key: id,
      id: id,
      cx: x,
      cy: y,
      r: radius,
      stroke: strokeColor,
      fill: strokeColor
    });
  } else {
    cov_20wqqco38b().b[1][1]++;
  }

  var d = (cov_20wqqco38b().s[5]++, paths.reduce(function (acc, point, i, a) {
    cov_20wqqco38b().f[1]++;
    cov_20wqqco38b().s[6]++;
    return i === 0 ? (cov_20wqqco38b().b[2][0]++, "M " + point.x + "," + point.y) : (cov_20wqqco38b().b[2][1]++, acc + " " + command(point, i, a));
  }, ''));
  cov_20wqqco38b().s[7]++;
  return React__namespace.createElement("path", {
    key: id,
    id: id,
    d: d,
    fill: "none",
    strokeLinecap: "round",
    stroke: strokeColor,
    strokeWidth: strokeWidth
  });
};
cov_20wqqco38b().s[8]++;
var line = function line(pointA, pointB) {
  cov_20wqqco38b().f[2]++;
  var lengthX = (cov_20wqqco38b().s[9]++, pointB.x - pointA.x);
  var lengthY = (cov_20wqqco38b().s[10]++, pointB.y - pointA.y);
  cov_20wqqco38b().s[11]++;
  return {
    length: Math.sqrt(Math.pow(lengthX, 2) + Math.pow(lengthY, 2)),
    angle: Math.atan2(lengthY, lengthX)
  };
};
cov_20wqqco38b().s[12]++;

var controlPoint = function controlPoint(controlPoints) {
  cov_20wqqco38b().f[3]++;

  var _ref3 = (cov_20wqqco38b().s[13]++, controlPoints),
      current = _ref3.current,
      next = _ref3.next,
      previous = _ref3.previous,
      reverse = _ref3.reverse;

  var p = (cov_20wqqco38b().s[14]++, (cov_20wqqco38b().b[3][0]++, previous) || (cov_20wqqco38b().b[3][1]++, current));
  var n = (cov_20wqqco38b().s[15]++, (cov_20wqqco38b().b[4][0]++, next) || (cov_20wqqco38b().b[4][1]++, current));
  var smoothing = (cov_20wqqco38b().s[16]++, 0.2);
  var o = (cov_20wqqco38b().s[17]++, line(p, n));
  var angle = (cov_20wqqco38b().s[18]++, o.angle + (reverse ? (cov_20wqqco38b().b[5][0]++, Math.PI) : (cov_20wqqco38b().b[5][1]++, 0)));
  var length = (cov_20wqqco38b().s[19]++, o.length * smoothing);
  var x = (cov_20wqqco38b().s[20]++, current.x + Math.cos(angle) * length);
  var y = (cov_20wqqco38b().s[21]++, current.y + Math.sin(angle) * length);
  cov_20wqqco38b().s[22]++;
  return [x, y];
};

cov_20wqqco38b().s[23]++;
var bezierCommand = function bezierCommand(point, i, a) {
  cov_20wqqco38b().f[4]++;
  var cpsX = (cov_20wqqco38b().s[24]++, null);
  var cpsY = (cov_20wqqco38b().s[25]++, null);
  cov_20wqqco38b().s[26]++;

  switch (i) {
    case 0:
      cov_20wqqco38b().b[6][0]++;
      cov_20wqqco38b().s[27]++;

      var _controlPoint = controlPoint({
        current: point
      });

      cpsX = _controlPoint[0];
      cpsY = _controlPoint[1];
      cov_20wqqco38b().s[28]++;
      break;

    case 1:
      cov_20wqqco38b().b[6][1]++;
      cov_20wqqco38b().s[29]++;

      var _controlPoint2 = controlPoint({
        current: a[i - 1],
        next: point
      });

      cpsX = _controlPoint2[0];
      cpsY = _controlPoint2[1];
      cov_20wqqco38b().s[30]++;
      break;

    default:
      cov_20wqqco38b().b[6][2]++;
      cov_20wqqco38b().s[31]++;

      var _controlPoint3 = controlPoint({
        current: a[i - 1],
        previous: a[i - 2],
        next: point
      });

      cpsX = _controlPoint3[0];
      cpsY = _controlPoint3[1];
      cov_20wqqco38b().s[32]++;
      break;
  }

  var _ref4 = (cov_20wqqco38b().s[33]++, controlPoint({
    current: point,
    previous: a[i - 1],
    next: a[i + 1],
    reverse: true
  })),
      cpeX = _ref4[0],
      cpeY = _ref4[1];

  cov_20wqqco38b().s[34]++;
  return "C " + cpsX + "," + cpsY + " " + cpeX + "," + cpeY + " " + point.x + ", " + point.y;
};
cov_20wqqco38b().s[35]++;

var Paths = function Paths(_ref5) {
  var paths = _ref5.paths;
  cov_20wqqco38b().f[5]++;
  cov_20wqqco38b().s[36]++;
  return React__namespace.createElement(React__namespace.Fragment, null, paths.map(function (path, id) {
    cov_20wqqco38b().f[6]++;
    cov_20wqqco38b().s[37]++;
    return React__namespace.createElement(SvgPath, {
      key: id.toString(),
      paths: path.paths,
      id: id.toString(),
      strokeWidth: path.strokeWidth,
      strokeColor: path.strokeColor,
      command: bezierCommand
    });
  }));
};

function cov_1z2c2igzc5() {
  var path = "/home/vinoth/projects/react-sketch-canvas/src/Canvas/index.tsx";
  var hash = "2065d442e1f4109464d7eb5ac8c97f93edfa0ef0";
  var global = new Function("return this")();
  var gcv = "__coverage__";
  var coverageData = {
    path: "/home/vinoth/projects/react-sketch-canvas/src/Canvas/index.tsx",
    statementMap: {
      "0": {
        start: {
          line: 4,
          column: 21
        },
        end: {
          line: 18,
          column: 1
        }
      },
      "1": {
        start: {
          line: 19,
          column: 18
        },
        end: {
          line: 30,
          column: 2
        }
      },
      "2": {
        start: {
          line: 19,
          column: 27
        },
        end: {
          line: 30,
          column: 2
        }
      },
      "3": {
        start: {
          line: 20,
          column: 16
        },
        end: {
          line: 20,
          column: 27
        }
      },
      "4": {
        start: {
          line: 21,
          column: 4
        },
        end: {
          line: 26,
          column: 7
        }
      },
      "5": {
        start: {
          line: 22,
          column: 8
        },
        end: {
          line: 24,
          column: 9
        }
      },
      "6": {
        start: {
          line: 23,
          column: 12
        },
        end: {
          line: 23,
          column: 25
        }
      },
      "7": {
        start: {
          line: 25,
          column: 8
        },
        end: {
          line: 25,
          column: 34
        }
      },
      "8": {
        start: {
          line: 27,
          column: 4
        },
        end: {
          line: 27,
          column: 56
        }
      },
      "9": {
        start: {
          line: 27,
          column: 43
        },
        end: {
          line: 27,
          column: 54
        }
      },
      "10": {
        start: {
          line: 28,
          column: 4
        },
        end: {
          line: 28,
          column: 18
        }
      },
      "11": {
        start: {
          line: 29,
          column: 4
        },
        end: {
          line: 29,
          column: 49
        }
      },
      "12": {
        start: {
          line: 32,
          column: 22
        },
        end: {
          line: 32,
          column: 56
        }
      },
      "13": {
        start: {
          line: 33,
          column: 18
        },
        end: {
          line: 33,
          column: 36
        }
      },
      "14": {
        start: {
          line: 34,
          column: 19
        },
        end: {
          line: 34,
          column: 38
        }
      },
      "15": {
        start: {
          line: 35,
          column: 4
        },
        end: {
          line: 35,
          column: 64
        }
      },
      "16": {
        start: {
          line: 36,
          column: 4
        },
        end: {
          line: 36,
          column: 54
        }
      },
      "17": {
        start: {
          line: 37,
          column: 4
        },
        end: {
          line: 37,
          column: 56
        }
      },
      "18": {
        start: {
          line: 38,
          column: 4
        },
        end: {
          line: 38,
          column: 40
        }
      },
      "19": {
        start: {
          line: 42,
          column: 26
        },
        end: {
          line: 42,
          column: 38
        }
      },
      "20": {
        start: {
          line: 44,
          column: 8
        },
        end: {
          line: 44,
          column: 21
        }
      },
      "21": {
        start: {
          line: 45,
          column: 8
        },
        end: {
          line: 45,
          column: 67
        }
      },
      "22": {
        start: {
          line: 46,
          column: 8
        },
        end: {
          line: 46,
          column: 67
        }
      },
      "23": {
        start: {
          line: 47,
          column: 8
        },
        end: {
          line: 47,
          column: 63
        }
      },
      "24": {
        start: {
          line: 48,
          column: 8
        },
        end: {
          line: 48,
          column: 61
        }
      },
      "25": {
        start: {
          line: 49,
          column: 8
        },
        end: {
          line: 49,
          column: 55
        }
      },
      "26": {
        start: {
          line: 50,
          column: 8
        },
        end: {
          line: 50,
          column: 51
        }
      },
      "27": {
        start: {
          line: 51,
          column: 8
        },
        end: {
          line: 51,
          column: 40
        }
      },
      "28": {
        start: {
          line: 56,
          column: 8
        },
        end: {
          line: 56,
          column: 69
        }
      },
      "29": {
        start: {
          line: 59,
          column: 8
        },
        end: {
          line: 59,
          column: 72
        }
      },
      "30": {
        start: {
          line: 63,
          column: 29
        },
        end: {
          line: 63,
          column: 73
        }
      },
      "31": {
        start: {
          line: 64,
          column: 27
        },
        end: {
          line: 64,
          column: 46
        }
      },
      "32": {
        start: {
          line: 65,
          column: 26
        },
        end: {
          line: 65,
          column: 45
        }
      },
      "33": {
        start: {
          line: 66,
          column: 8
        },
        end: {
          line: 68,
          column: 9
        }
      },
      "34": {
        start: {
          line: 67,
          column: 12
        },
        end: {
          line: 67,
          column: 34
        }
      },
      "35": {
        start: {
          line: 69,
          column: 22
        },
        end: {
          line: 72,
          column: 9
        }
      },
      "36": {
        start: {
          line: 73,
          column: 8
        },
        end: {
          line: 73,
          column: 21
        }
      },
      "37": {
        start: {
          line: 78,
          column: 56
        },
        end: {
          line: 78,
          column: 66
        }
      },
      "38": {
        start: {
          line: 79,
          column: 8
        },
        end: {
          line: 82,
          column: 9
        }
      },
      "39": {
        start: {
          line: 81,
          column: 12
        },
        end: {
          line: 81,
          column: 19
        }
      },
      "40": {
        start: {
          line: 83,
          column: 8
        },
        end: {
          line: 84,
          column: 19
        }
      },
      "41": {
        start: {
          line: 84,
          column: 12
        },
        end: {
          line: 84,
          column: 19
        }
      },
      "42": {
        start: {
          line: 85,
          column: 22
        },
        end: {
          line: 85,
          column: 48
        }
      },
      "43": {
        start: {
          line: 86,
          column: 8
        },
        end: {
          line: 86,
          column: 29
        }
      },
      "44": {
        start: {
          line: 89,
          column: 67
        },
        end: {
          line: 89,
          column: 77
        }
      },
      "45": {
        start: {
          line: 90,
          column: 8
        },
        end: {
          line: 91,
          column: 19
        }
      },
      "46": {
        start: {
          line: 91,
          column: 12
        },
        end: {
          line: 91,
          column: 19
        }
      },
      "47": {
        start: {
          line: 93,
          column: 8
        },
        end: {
          line: 96,
          column: 9
        }
      },
      "48": {
        start: {
          line: 95,
          column: 12
        },
        end: {
          line: 95,
          column: 19
        }
      },
      "49": {
        start: {
          line: 97,
          column: 22
        },
        end: {
          line: 97,
          column: 48
        }
      },
      "50": {
        start: {
          line: 98,
          column: 8
        },
        end: {
          line: 98,
          column: 29
        }
      },
      "51": {
        start: {
          line: 101,
          column: 8
        },
        end: {
          line: 102,
          column: 19
        }
      },
      "52": {
        start: {
          line: 102,
          column: 12
        },
        end: {
          line: 102,
          column: 19
        }
      },
      "53": {
        start: {
          line: 104,
          column: 54
        },
        end: {
          line: 104,
          column: 64
        }
      },
      "54": {
        start: {
          line: 105,
          column: 8
        },
        end: {
          line: 108,
          column: 9
        }
      },
      "55": {
        start: {
          line: 107,
          column: 12
        },
        end: {
          line: 107,
          column: 19
        }
      },
      "56": {
        start: {
          line: 109,
          column: 8
        },
        end: {
          line: 109,
          column: 22
        }
      },
      "57": {
        start: {
          line: 114,
          column: 8
        },
        end: {
          line: 154,
          column: 11
        }
      },
      "58": {
        start: {
          line: 115,
          column: 12
        },
        end: {
          line: 153,
          column: 13
        }
      },
      "59": {
        start: {
          line: 116,
          column: 31
        },
        end: {
          line: 116,
          column: 50
        }
      },
      "60": {
        start: {
          line: 117,
          column: 16
        },
        end: {
          line: 119,
          column: 17
        }
      },
      "61": {
        start: {
          line: 118,
          column: 20
        },
        end: {
          line: 118,
          column: 59
        }
      },
      "62": {
        start: {
          line: 120,
          column: 71
        },
        end: {
          line: 120,
          column: 81
        }
      },
      "63": {
        start: {
          line: 121,
          column: 53
        },
        end: {
          line: 121,
          column: 81
        }
      },
      "64": {
        start: {
          line: 122,
          column: 37
        },
        end: {
          line: 122,
          column: 93
        }
      },
      "65": {
        start: {
          line: 123,
          column: 42
        },
        end: {
          line: 123,
          column: 73
        }
      },
      "66": {
        start: {
          line: 124,
          column: 16
        },
        end: {
          line: 132,
          column: 17
        }
      },
      "67": {
        start: {
          line: 125,
          column: 20
        },
        end: {
          line: 131,
          column: 21
        }
      },
      "68": {
        start: {
          line: 126,
          column: 36
        },
        end: {
          line: 126,
          column: 68
        }
      },
      "69": {
        start: {
          line: 127,
          column: 24
        },
        end: {
          line: 127,
          column: 52
        }
      },
      "70": {
        start: {
          line: 130,
          column: 24
        },
        end: {
          line: 130,
          column: 140
        }
      },
      "71": {
        start: {
          line: 133,
          column: 16
        },
        end: {
          line: 149,
          column: 19
        }
      },
      "72": {
        start: {
          line: 135,
          column: 41
        },
        end: {
          line: 135,
          column: 73
        }
      },
      "73": {
        start: {
          line: 136,
          column: 20
        },
        end: {
          line: 136,
          column: 73
        }
      },
      "74": {
        start: {
          line: 137,
          column: 20
        },
        end: {
          line: 137,
          column: 75
        }
      },
      "75": {
        start: {
          line: 138,
          column: 36
        },
        end: {
          line: 138,
          column: 65
        }
      },
      "76": {
        start: {
          line: 139,
          column: 20
        },
        end: {
          line: 141,
          column: 21
        }
      },
      "77": {
        start: {
          line: 140,
          column: 24
        },
        end: {
          line: 140,
          column: 63
        }
      },
      "78": {
        start: {
          line: 142,
          column: 20
        },
        end: {
          line: 144,
          column: 23
        }
      },
      "79": {
        start: {
          line: 143,
          column: 24
        },
        end: {
          line: 143,
          column: 55
        }
      },
      "80": {
        start: {
          line: 145,
          column: 20
        },
        end: {
          line: 145,
          column: 74
        }
      },
      "81": {
        start: {
          line: 148,
          column: 20
        },
        end: {
          line: 148,
          column: 28
        }
      },
      "82": {
        start: {
          line: 152,
          column: 16
        },
        end: {
          line: 152,
          column: 26
        }
      },
      "83": {
        start: {
          line: 157,
          column: 8
        },
        end: {
          line: 178,
          column: 11
        }
      },
      "84": {
        start: {
          line: 158,
          column: 12
        },
        end: {
          line: 177,
          column: 13
        }
      },
      "85": {
        start: {
          line: 159,
          column: 31
        },
        end: {
          line: 159,
          column: 59
        }
      },
      "86": {
        start: {
          line: 160,
          column: 16
        },
        end: {
          line: 172,
          column: 17
        }
      },
      "87": {
        start: {
          line: 161,
          column: 42
        },
        end: {
          line: 161,
          column: 70
        }
      },
      "88": {
        start: {
          line: 162,
          column: 71
        },
        end: {
          line: 162,
          column: 81
        }
      },
      "89": {
        start: {
          line: 163,
          column: 20
        },
        end: {
          line: 166,
          column: 21
        }
      },
      "90": {
        start: {
          line: 164,
          column: 24
        },
        end: {
          line: 164,
          column: 53
        }
      },
      "91": {
        start: {
          line: 165,
          column: 24
        },
        end: {
          line: 165,
          column: 31
        }
      },
      "92": {
        start: {
          line: 167,
          column: 20
        },
        end: {
          line: 167,
          column: 69
        }
      },
      "93": {
        start: {
          line: 168,
          column: 20
        },
        end: {
          line: 170,
          column: 60
        }
      },
      "94": {
        start: {
          line: 171,
          column: 20
        },
        end: {
          line: 171,
          column: 49
        }
      },
      "95": {
        start: {
          line: 173,
          column: 16
        },
        end: {
          line: 173,
          column: 55
        }
      },
      "96": {
        start: {
          line: 176,
          column: 16
        },
        end: {
          line: 176,
          column: 26
        }
      },
      "97": {
        start: {
          line: 182,
          column: 126
        },
        end: {
          line: 182,
          column: 136
        }
      },
      "98": {
        start: {
          line: 183,
          column: 28
        },
        end: {
          line: 183,
          column: 66
        }
      },
      "99": {
        start: {
          line: 183,
          column: 51
        },
        end: {
          line: 183,
          column: 65
        }
      },
      "100": {
        start: {
          line: 184,
          column: 27
        },
        end: {
          line: 184,
          column: 28
        }
      },
      "101": {
        start: {
          line: 185,
          column: 27
        },
        end: {
          line: 195,
          column: 16
        }
      },
      "102": {
        start: {
          line: 186,
          column: 12
        },
        end: {
          line: 189,
          column: 13
        }
      },
      "103": {
        start: {
          line: 187,
          column: 16
        },
        end: {
          line: 187,
          column: 34
        }
      },
      "104": {
        start: {
          line: 188,
          column: 16
        },
        end: {
          line: 188,
          column: 34
        }
      },
      "105": {
        start: {
          line: 190,
          column: 12
        },
        end: {
          line: 192,
          column: 13
        }
      },
      "106": {
        start: {
          line: 191,
          column: 16
        },
        end: {
          line: 191,
          column: 46
        }
      },
      "107": {
        start: {
          line: 193,
          column: 12
        },
        end: {
          line: 193,
          column: 48
        }
      },
      "108": {
        start: {
          line: 194,
          column: 12
        },
        end: {
          line: 194,
          column: 30
        }
      },
      "109": {
        start: {
          line: 196,
          column: 8
        },
        end: {
          line: 218,
          column: 75
        }
      },
      "110": {
        start: {
          line: 208,
          column: 56
        },
        end: {
          line: 208,
          column: 213
        }
      },
      "111": {
        start: {
          line: 212,
          column: 47
        },
        end: {
          line: 214,
          column: 185
        }
      },
      "112": {
        start: {
          line: 214,
          column: 81
        },
        end: {
          line: 214,
          column: 86
        }
      },
      "113": {
        start: {
          line: 214,
          column: 100
        },
        end: {
          line: 214,
          column: 182
        }
      },
      "114": {
        start: {
          line: 217,
          column: 50
        },
        end: {
          line: 218,
          column: 69
        }
      }
    },
    fnMap: {
      "0": {
        name: "(anonymous_0)",
        decl: {
          start: {
            line: 19,
            column: 18
          },
          end: {
            line: 19,
            column: 19
          }
        },
        loc: {
          start: {
            line: 19,
            column: 27
          },
          end: {
            line: 30,
            column: 2
          }
        },
        line: 19
      },
      "1": {
        name: "(anonymous_1)",
        decl: {
          start: {
            line: 19,
            column: 39
          },
          end: {
            line: 19,
            column: 40
          }
        },
        loc: {
          start: {
            line: 19,
            column: 60
          },
          end: {
            line: 30,
            column: 1
          }
        },
        line: 19
      },
      "2": {
        name: "(anonymous_2)",
        decl: {
          start: {
            line: 21,
            column: 33
          },
          end: {
            line: 21,
            column: 34
          }
        },
        loc: {
          start: {
            line: 21,
            column: 39
          },
          end: {
            line: 26,
            column: 5
          }
        },
        line: 21
      },
      "3": {
        name: "(anonymous_3)",
        decl: {
          start: {
            line: 27,
            column: 34
          },
          end: {
            line: 27,
            column: 35
          }
        },
        loc: {
          start: {
            line: 27,
            column: 43
          },
          end: {
            line: 27,
            column: 54
          }
        },
        line: 27
      },
      "4": {
        name: "getCanvasWithViewBox",
        decl: {
          start: {
            line: 31,
            column: 9
          },
          end: {
            line: 31,
            column: 29
          }
        },
        loc: {
          start: {
            line: 31,
            column: 38
          },
          end: {
            line: 39,
            column: 1
          }
        },
        line: 31
      },
      "5": {
        name: "(anonymous_5)",
        decl: {
          start: {
            line: 43,
            column: 4
          },
          end: {
            line: 43,
            column: 5
          }
        },
        loc: {
          start: {
            line: 43,
            column: 23
          },
          end: {
            line: 52,
            column: 5
          }
        },
        line: 43
      },
      "6": {
        name: "(anonymous_6)",
        decl: {
          start: {
            line: 55,
            column: 4
          },
          end: {
            line: 55,
            column: 5
          }
        },
        loc: {
          start: {
            line: 55,
            column: 24
          },
          end: {
            line: 57,
            column: 5
          }
        },
        line: 55
      },
      "7": {
        name: "(anonymous_7)",
        decl: {
          start: {
            line: 58,
            column: 4
          },
          end: {
            line: 58,
            column: 5
          }
        },
        loc: {
          start: {
            line: 58,
            column: 27
          },
          end: {
            line: 60,
            column: 5
          }
        },
        line: 58
      },
      "8": {
        name: "(anonymous_8)",
        decl: {
          start: {
            line: 62,
            column: 4
          },
          end: {
            line: 62,
            column: 5
          }
        },
        loc: {
          start: {
            line: 62,
            column: 33
          },
          end: {
            line: 74,
            column: 5
          }
        },
        line: 62
      },
      "9": {
        name: "(anonymous_9)",
        decl: {
          start: {
            line: 76,
            column: 4
          },
          end: {
            line: 76,
            column: 5
          }
        },
        loc: {
          start: {
            line: 76,
            column: 29
          },
          end: {
            line: 87,
            column: 5
          }
        },
        line: 76
      },
      "10": {
        name: "(anonymous_10)",
        decl: {
          start: {
            line: 88,
            column: 4
          },
          end: {
            line: 88,
            column: 5
          }
        },
        loc: {
          start: {
            line: 88,
            column: 29
          },
          end: {
            line: 99,
            column: 5
          }
        },
        line: 88
      },
      "11": {
        name: "(anonymous_11)",
        decl: {
          start: {
            line: 100,
            column: 4
          },
          end: {
            line: 100,
            column: 5
          }
        },
        loc: {
          start: {
            line: 100,
            column: 27
          },
          end: {
            line: 110,
            column: 5
          }
        },
        line: 100
      },
      "12": {
        name: "(anonymous_12)",
        decl: {
          start: {
            line: 113,
            column: 4
          },
          end: {
            line: 113,
            column: 5
          }
        },
        loc: {
          start: {
            line: 113,
            column: 27
          },
          end: {
            line: 155,
            column: 5
          }
        },
        line: 113
      },
      "13": {
        name: "(anonymous_13)",
        decl: {
          start: {
            line: 114,
            column: 27
          },
          end: {
            line: 114,
            column: 28
          }
        },
        loc: {
          start: {
            line: 114,
            column: 54
          },
          end: {
            line: 154,
            column: 9
          }
        },
        line: 114
      },
      "14": {
        name: "(anonymous_14)",
        decl: {
          start: {
            line: 134,
            column: 26
          },
          end: {
            line: 134,
            column: 27
          }
        },
        loc: {
          start: {
            line: 134,
            column: 38
          },
          end: {
            line: 146,
            column: 17
          }
        },
        line: 134
      },
      "15": {
        name: "(anonymous_15)",
        decl: {
          start: {
            line: 142,
            column: 45
          },
          end: {
            line: 142,
            column: 46
          }
        },
        loc: {
          start: {
            line: 142,
            column: 56
          },
          end: {
            line: 144,
            column: 21
          }
        },
        line: 142
      },
      "16": {
        name: "(anonymous_16)",
        decl: {
          start: {
            line: 147,
            column: 27
          },
          end: {
            line: 147,
            column: 28
          }
        },
        loc: {
          start: {
            line: 147,
            column: 34
          },
          end: {
            line: 149,
            column: 17
          }
        },
        line: 147
      },
      "17": {
        name: "(anonymous_17)",
        decl: {
          start: {
            line: 156,
            column: 4
          },
          end: {
            line: 156,
            column: 5
          }
        },
        loc: {
          start: {
            line: 156,
            column: 16
          },
          end: {
            line: 179,
            column: 5
          }
        },
        line: 156
      },
      "18": {
        name: "(anonymous_18)",
        decl: {
          start: {
            line: 157,
            column: 27
          },
          end: {
            line: 157,
            column: 28
          }
        },
        loc: {
          start: {
            line: 157,
            column: 48
          },
          end: {
            line: 178,
            column: 9
          }
        },
        line: 157
      },
      "19": {
        name: "(anonymous_19)",
        decl: {
          start: {
            line: 181,
            column: 4
          },
          end: {
            line: 181,
            column: 5
          }
        },
        loc: {
          start: {
            line: 181,
            column: 13
          },
          end: {
            line: 219,
            column: 5
          }
        },
        line: 181
      },
      "20": {
        name: "(anonymous_20)",
        decl: {
          start: {
            line: 183,
            column: 41
          },
          end: {
            line: 183,
            column: 42
          }
        },
        loc: {
          start: {
            line: 183,
            column: 51
          },
          end: {
            line: 183,
            column: 65
          }
        },
        line: 183
      },
      "21": {
        name: "(anonymous_21)",
        decl: {
          start: {
            line: 185,
            column: 40
          },
          end: {
            line: 185,
            column: 41
          }
        },
        loc: {
          start: {
            line: 185,
            column: 62
          },
          end: {
            line: 195,
            column: 9
          }
        },
        line: 185
      },
      "22": {
        name: "(anonymous_22)",
        decl: {
          start: {
            line: 208,
            column: 36
          },
          end: {
            line: 208,
            column: 37
          }
        },
        loc: {
          start: {
            line: 208,
            column: 56
          },
          end: {
            line: 208,
            column: 213
          }
        },
        line: 208
      },
      "23": {
        name: "(anonymous_23)",
        decl: {
          start: {
            line: 212,
            column: 36
          },
          end: {
            line: 212,
            column: 37
          }
        },
        loc: {
          start: {
            line: 212,
            column: 47
          },
          end: {
            line: 214,
            column: 185
          }
        },
        line: 212
      },
      "24": {
        name: "(anonymous_24)",
        decl: {
          start: {
            line: 214,
            column: 71
          },
          end: {
            line: 214,
            column: 72
          }
        },
        loc: {
          start: {
            line: 214,
            column: 81
          },
          end: {
            line: 214,
            column: 86
          }
        },
        line: 214
      },
      "25": {
        name: "(anonymous_25)",
        decl: {
          start: {
            line: 214,
            column: 92
          },
          end: {
            line: 214,
            column: 93
          }
        },
        loc: {
          start: {
            line: 214,
            column: 100
          },
          end: {
            line: 214,
            column: 182
          }
        },
        line: 214
      },
      "26": {
        name: "(anonymous_26)",
        decl: {
          start: {
            line: 217,
            column: 31
          },
          end: {
            line: 217,
            column: 32
          }
        },
        loc: {
          start: {
            line: 217,
            column: 50
          },
          end: {
            line: 218,
            column: 69
          }
        },
        line: 217
      }
    },
    branchMap: {
      "0": {
        loc: {
          start: {
            line: 22,
            column: 8
          },
          end: {
            line: 24,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 22,
            column: 8
          },
          end: {
            line: 24,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 22
      },
      "1": {
        loc: {
          start: {
            line: 64,
            column: 27
          },
          end: {
            line: 64,
            column: 46
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 64,
            column: 27
          },
          end: {
            line: 64,
            column: 41
          }
        }, {
          start: {
            line: 64,
            column: 45
          },
          end: {
            line: 64,
            column: 46
          }
        }],
        line: 64
      },
      "2": {
        loc: {
          start: {
            line: 65,
            column: 26
          },
          end: {
            line: 65,
            column: 45
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 65,
            column: 26
          },
          end: {
            line: 65,
            column: 40
          }
        }, {
          start: {
            line: 65,
            column: 44
          },
          end: {
            line: 65,
            column: 45
          }
        }],
        line: 65
      },
      "3": {
        loc: {
          start: {
            line: 66,
            column: 8
          },
          end: {
            line: 68,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 66,
            column: 8
          },
          end: {
            line: 68,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 66
      },
      "4": {
        loc: {
          start: {
            line: 79,
            column: 8
          },
          end: {
            line: 82,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 79,
            column: 8
          },
          end: {
            line: 82,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 79
      },
      "5": {
        loc: {
          start: {
            line: 79,
            column: 12
          },
          end: {
            line: 80,
            column: 54
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 79,
            column: 12
          },
          end: {
            line: 79,
            column: 42
          }
        }, {
          start: {
            line: 80,
            column: 12
          },
          end: {
            line: 80,
            column: 54
          }
        }],
        line: 79
      },
      "6": {
        loc: {
          start: {
            line: 83,
            column: 8
          },
          end: {
            line: 84,
            column: 19
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 83,
            column: 8
          },
          end: {
            line: 84,
            column: 19
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 83
      },
      "7": {
        loc: {
          start: {
            line: 83,
            column: 12
          },
          end: {
            line: 83,
            column: 63
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 83,
            column: 12
          },
          end: {
            line: 83,
            column: 41
          }
        }, {
          start: {
            line: 83,
            column: 45
          },
          end: {
            line: 83,
            column: 63
          }
        }],
        line: 83
      },
      "8": {
        loc: {
          start: {
            line: 90,
            column: 8
          },
          end: {
            line: 91,
            column: 19
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 90,
            column: 8
          },
          end: {
            line: 91,
            column: 19
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 90
      },
      "9": {
        loc: {
          start: {
            line: 93,
            column: 8
          },
          end: {
            line: 96,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 93,
            column: 8
          },
          end: {
            line: 96,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 93
      },
      "10": {
        loc: {
          start: {
            line: 93,
            column: 12
          },
          end: {
            line: 94,
            column: 54
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 93,
            column: 12
          },
          end: {
            line: 93,
            column: 42
          }
        }, {
          start: {
            line: 94,
            column: 12
          },
          end: {
            line: 94,
            column: 54
          }
        }],
        line: 93
      },
      "11": {
        loc: {
          start: {
            line: 101,
            column: 8
          },
          end: {
            line: 102,
            column: 19
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 101,
            column: 8
          },
          end: {
            line: 102,
            column: 19
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 101
      },
      "12": {
        loc: {
          start: {
            line: 101,
            column: 12
          },
          end: {
            line: 101,
            column: 63
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 101,
            column: 12
          },
          end: {
            line: 101,
            column: 41
          }
        }, {
          start: {
            line: 101,
            column: 45
          },
          end: {
            line: 101,
            column: 63
          }
        }],
        line: 101
      },
      "13": {
        loc: {
          start: {
            line: 105,
            column: 8
          },
          end: {
            line: 108,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 105,
            column: 8
          },
          end: {
            line: 108,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 105
      },
      "14": {
        loc: {
          start: {
            line: 105,
            column: 12
          },
          end: {
            line: 106,
            column: 54
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 105,
            column: 12
          },
          end: {
            line: 105,
            column: 42
          }
        }, {
          start: {
            line: 106,
            column: 12
          },
          end: {
            line: 106,
            column: 54
          }
        }],
        line: 105
      },
      "15": {
        loc: {
          start: {
            line: 117,
            column: 16
          },
          end: {
            line: 119,
            column: 17
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 117,
            column: 16
          },
          end: {
            line: 119,
            column: 17
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 117
      },
      "16": {
        loc: {
          start: {
            line: 124,
            column: 16
          },
          end: {
            line: 132,
            column: 17
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 124,
            column: 16
          },
          end: {
            line: 132,
            column: 17
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 124
      },
      "17": {
        loc: {
          start: {
            line: 139,
            column: 20
          },
          end: {
            line: 141,
            column: 21
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 139,
            column: 20
          },
          end: {
            line: 141,
            column: 21
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 139
      },
      "18": {
        loc: {
          start: {
            line: 159,
            column: 31
          },
          end: {
            line: 159,
            column: 59
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 159,
            column: 31
          },
          end: {
            line: 159,
            column: 51
          }
        }, {
          start: {
            line: 159,
            column: 55
          },
          end: {
            line: 159,
            column: 59
          }
        }],
        line: 159
      },
      "19": {
        loc: {
          start: {
            line: 160,
            column: 16
          },
          end: {
            line: 172,
            column: 17
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 160,
            column: 16
          },
          end: {
            line: 172,
            column: 17
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 160
      },
      "20": {
        loc: {
          start: {
            line: 163,
            column: 20
          },
          end: {
            line: 166,
            column: 21
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 163,
            column: 20
          },
          end: {
            line: 166,
            column: 21
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 163
      },
      "21": {
        loc: {
          start: {
            line: 186,
            column: 12
          },
          end: {
            line: 189,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 186,
            column: 12
          },
          end: {
            line: 189,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 186
      },
      "22": {
        loc: {
          start: {
            line: 190,
            column: 12
          },
          end: {
            line: 192,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 190,
            column: 12
          },
          end: {
            line: 192,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 190
      },
      "23": {
        loc: {
          start: {
            line: 210,
            column: 20
          },
          end: {
            line: 211,
            column: 190
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 210,
            column: 20
          },
          end: {
            line: 210,
            column: 35
          }
        }, {
          start: {
            line: 210,
            column: 40
          },
          end: {
            line: 211,
            column: 189
          }
        }],
        line: 210
      },
      "24": {
        loc: {
          start: {
            line: 216,
            column: 128
          },
          end: {
            line: 216,
            column: 178
          }
        },
        type: "cond-expr",
        locations: [{
          start: {
            line: 216,
            column: 146
          },
          end: {
            line: 216,
            column: 164
          }
        }, {
          start: {
            line: 216,
            column: 167
          },
          end: {
            line: 216,
            column: 178
          }
        }],
        line: 216
      }
    },
    s: {
      "0": 0,
      "1": 0,
      "2": 0,
      "3": 0,
      "4": 0,
      "5": 0,
      "6": 0,
      "7": 0,
      "8": 0,
      "9": 0,
      "10": 0,
      "11": 0,
      "12": 0,
      "13": 0,
      "14": 0,
      "15": 0,
      "16": 0,
      "17": 0,
      "18": 0,
      "19": 0,
      "20": 0,
      "21": 0,
      "22": 0,
      "23": 0,
      "24": 0,
      "25": 0,
      "26": 0,
      "27": 0,
      "28": 0,
      "29": 0,
      "30": 0,
      "31": 0,
      "32": 0,
      "33": 0,
      "34": 0,
      "35": 0,
      "36": 0,
      "37": 0,
      "38": 0,
      "39": 0,
      "40": 0,
      "41": 0,
      "42": 0,
      "43": 0,
      "44": 0,
      "45": 0,
      "46": 0,
      "47": 0,
      "48": 0,
      "49": 0,
      "50": 0,
      "51": 0,
      "52": 0,
      "53": 0,
      "54": 0,
      "55": 0,
      "56": 0,
      "57": 0,
      "58": 0,
      "59": 0,
      "60": 0,
      "61": 0,
      "62": 0,
      "63": 0,
      "64": 0,
      "65": 0,
      "66": 0,
      "67": 0,
      "68": 0,
      "69": 0,
      "70": 0,
      "71": 0,
      "72": 0,
      "73": 0,
      "74": 0,
      "75": 0,
      "76": 0,
      "77": 0,
      "78": 0,
      "79": 0,
      "80": 0,
      "81": 0,
      "82": 0,
      "83": 0,
      "84": 0,
      "85": 0,
      "86": 0,
      "87": 0,
      "88": 0,
      "89": 0,
      "90": 0,
      "91": 0,
      "92": 0,
      "93": 0,
      "94": 0,
      "95": 0,
      "96": 0,
      "97": 0,
      "98": 0,
      "99": 0,
      "100": 0,
      "101": 0,
      "102": 0,
      "103": 0,
      "104": 0,
      "105": 0,
      "106": 0,
      "107": 0,
      "108": 0,
      "109": 0,
      "110": 0,
      "111": 0,
      "112": 0,
      "113": 0,
      "114": 0
    },
    f: {
      "0": 0,
      "1": 0,
      "2": 0,
      "3": 0,
      "4": 0,
      "5": 0,
      "6": 0,
      "7": 0,
      "8": 0,
      "9": 0,
      "10": 0,
      "11": 0,
      "12": 0,
      "13": 0,
      "14": 0,
      "15": 0,
      "16": 0,
      "17": 0,
      "18": 0,
      "19": 0,
      "20": 0,
      "21": 0,
      "22": 0,
      "23": 0,
      "24": 0,
      "25": 0,
      "26": 0
    },
    b: {
      "0": [0, 0],
      "1": [0, 0],
      "2": [0, 0],
      "3": [0, 0],
      "4": [0, 0],
      "5": [0, 0],
      "6": [0, 0],
      "7": [0, 0],
      "8": [0, 0],
      "9": [0, 0],
      "10": [0, 0],
      "11": [0, 0],
      "12": [0, 0],
      "13": [0, 0],
      "14": [0, 0],
      "15": [0, 0],
      "16": [0, 0],
      "17": [0, 0],
      "18": [0, 0],
      "19": [0, 0],
      "20": [0, 0],
      "21": [0, 0],
      "22": [0, 0],
      "23": [0, 0],
      "24": [0, 0]
    },
    _coverageSchema: "1a1c01bbd47fc00a2c39e90264f33305004495a9",
    hash: "2065d442e1f4109464d7eb5ac8c97f93edfa0ef0"
  };
  var coverage = global[gcv] || (global[gcv] = {});

  if (!coverage[path] || coverage[path].hash !== hash) {
    coverage[path] = coverageData;
  }

  var actualCoverage = coverage[path];
  {
    // @ts-ignore
    cov_1z2c2igzc5 = function () {
      return actualCoverage;
    };
  }
  return actualCoverage;
}

cov_1z2c2igzc5();
/* Default settings */

var defaultProps$1 = ( cov_1z2c2igzc5().s[0]++, {
  width: '100%',
  height: '100%',
  className: '',
  canvasColor: 'red',
  backgroundImage: '',
  exportWithBackgroundImage: true,
  preserveBackgroundImageAspectRatio: 'none',
  allowOnlyPointerType: 'all',
  style: {
    border: '0.0625rem solid #9c9c9c',
    borderRadius: '0.25rem'
  },
  withTimeStamp: true
});
cov_1z2c2igzc5().s[1]++;

var loadImage = function loadImage(url) {
  cov_1z2c2igzc5().f[0]++;
  cov_1z2c2igzc5().s[2]++;
  return new Promise(function (resolve, reject) {
    cov_1z2c2igzc5().f[1]++;
    var img = (cov_1z2c2igzc5().s[3]++, new Image());
    cov_1z2c2igzc5().s[4]++;
    img.addEventListener('load', function () {
      cov_1z2c2igzc5().f[2]++;
      cov_1z2c2igzc5().s[5]++;

      if (img.width > 0) {
        cov_1z2c2igzc5().b[0][0]++;
        cov_1z2c2igzc5().s[6]++;
        resolve(img);
      } else {
        cov_1z2c2igzc5().b[0][1]++;
      }

      cov_1z2c2igzc5().s[7]++;
      reject('Image not found');
    });
    cov_1z2c2igzc5().s[8]++;
    img.addEventListener('error', function (err) {
      cov_1z2c2igzc5().f[3]++;
      cov_1z2c2igzc5().s[9]++;
      return reject(err);
    });
    cov_1z2c2igzc5().s[10]++;
    img.src = url;
    cov_1z2c2igzc5().s[11]++;
    img.setAttribute('crossorigin', 'anonymous');
  });
};

function getCanvasWithViewBox(canvas) {
  var _canvas$firstChild;

  cov_1z2c2igzc5().f[4]++;
  var svgCanvas = (cov_1z2c2igzc5().s[12]++, (_canvas$firstChild = canvas.firstChild) == null ? void 0 : _canvas$firstChild.cloneNode(true));
  var width = (cov_1z2c2igzc5().s[13]++, canvas.offsetWidth);
  var height = (cov_1z2c2igzc5().s[14]++, canvas.offsetHeight);
  cov_1z2c2igzc5().s[15]++;
  svgCanvas.setAttribute('viewBox', "0 0 " + width + " " + height);
  cov_1z2c2igzc5().s[16]++;
  svgCanvas.setAttribute('width', width.toString());
  cov_1z2c2igzc5().s[17]++;
  svgCanvas.setAttribute('height', height.toString());
  cov_1z2c2igzc5().s[18]++;
  return {
    svgCanvas: svgCanvas,
    width: width,
    height: height
  };
}

var Canvas = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Canvas, _React$Component);

  function Canvas(props) {
    var _this;

    cov_1z2c2igzc5().f[5]++;
    cov_1z2c2igzc5().s[20]++;
    _this = _React$Component.call(this, props) || this;
    _this.canvas = void 0;
    cov_1z2c2igzc5().s[21]++;
    _this.handlePointerDown = _this.handlePointerDown.bind(_assertThisInitialized(_this));
    cov_1z2c2igzc5().s[22]++;
    _this.handlePointerMove = _this.handlePointerMove.bind(_assertThisInitialized(_this));
    cov_1z2c2igzc5().s[23]++;
    _this.handlePointerUp = _this.handlePointerUp.bind(_assertThisInitialized(_this));
    cov_1z2c2igzc5().s[24]++;
    _this.getCoordinates = _this.getCoordinates.bind(_assertThisInitialized(_this));
    cov_1z2c2igzc5().s[25]++;
    _this.exportImage = _this.exportImage.bind(_assertThisInitialized(_this));
    cov_1z2c2igzc5().s[26]++;
    _this.exportSvg = _this.exportSvg.bind(_assertThisInitialized(_this));
    cov_1z2c2igzc5().s[27]++;
    _this.canvas = React__namespace.createRef();
    return _this;
  }
  /* Add event listener to Mouse up and Touch up to
  release drawing even when point goes out of canvas */


  var _proto = Canvas.prototype;

  _proto.componentDidMount = function componentDidMount() {
    cov_1z2c2igzc5().f[6]++;
    cov_1z2c2igzc5().s[28]++;
    document.addEventListener('pointerup', this.handlePointerUp);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    cov_1z2c2igzc5().f[7]++;
    cov_1z2c2igzc5().s[29]++;
    document.removeEventListener('pointerup', this.handlePointerUp);
  } // Converts mouse coordinates to relative coordinate based on the absolute position of svg
  ;

  _proto.getCoordinates = function getCoordinates(pointerEvent) {
    var _this$canvas$current, _ref, _ref2;

    cov_1z2c2igzc5().f[8]++;
    var boundingArea = (cov_1z2c2igzc5().s[30]++, (_this$canvas$current = this.canvas.current) == null ? void 0 : _this$canvas$current.getBoundingClientRect());
    var scrollLeft = (cov_1z2c2igzc5().s[31]++, (_ref = (cov_1z2c2igzc5().b[1][0]++, window.scrollX)) != null ? _ref : (cov_1z2c2igzc5().b[1][1]++, 0));
    var scrollTop = (cov_1z2c2igzc5().s[32]++, (_ref2 = (cov_1z2c2igzc5().b[2][0]++, window.scrollY)) != null ? _ref2 : (cov_1z2c2igzc5().b[2][1]++, 0));
    cov_1z2c2igzc5().s[33]++;

    if (!boundingArea) {
      cov_1z2c2igzc5().b[3][0]++;
      cov_1z2c2igzc5().s[34]++;
      return {
        x: 0,
        y: 0
      };
    } else {
      cov_1z2c2igzc5().b[3][1]++;
    }

    var point = (cov_1z2c2igzc5().s[35]++, {
      x: pointerEvent.pageX - boundingArea.left - scrollLeft,
      y: pointerEvent.pageY - boundingArea.top - scrollTop
    });
    cov_1z2c2igzc5().s[36]++;
    return point;
  }
  /* Mouse Handlers - Mouse down, move and up */
  ;

  _proto.handlePointerDown = function handlePointerDown(event) {
    cov_1z2c2igzc5().f[9]++;

    // Allow only chosen pointer type
    var _ref3 = (cov_1z2c2igzc5().s[37]++, this.props),
        allowOnlyPointerType = _ref3.allowOnlyPointerType,
        onPointerDown = _ref3.onPointerDown;

    cov_1z2c2igzc5().s[38]++;

    if ((cov_1z2c2igzc5().b[5][0]++, allowOnlyPointerType !== 'all') && (cov_1z2c2igzc5().b[5][1]++, event.pointerType !== allowOnlyPointerType)) {
      cov_1z2c2igzc5().b[4][0]++;
      cov_1z2c2igzc5().s[39]++;
      return;
    } else {
      cov_1z2c2igzc5().b[4][1]++;
    }

    cov_1z2c2igzc5().s[40]++;

    if ((cov_1z2c2igzc5().b[7][0]++, event.pointerType === 'mouse') && (cov_1z2c2igzc5().b[7][1]++, event.button !== 0)) {
      cov_1z2c2igzc5().b[6][0]++;
      cov_1z2c2igzc5().s[41]++;
      return;
    } else {
      cov_1z2c2igzc5().b[6][1]++;
    }

    var point = (cov_1z2c2igzc5().s[42]++, this.getCoordinates(event));
    cov_1z2c2igzc5().s[43]++;
    onPointerDown(point);
  };

  _proto.handlePointerMove = function handlePointerMove(event) {
    cov_1z2c2igzc5().f[10]++;

    var _ref4 = (cov_1z2c2igzc5().s[44]++, this.props),
        isDrawing = _ref4.isDrawing,
        allowOnlyPointerType = _ref4.allowOnlyPointerType,
        onPointerMove = _ref4.onPointerMove;

    cov_1z2c2igzc5().s[45]++;

    if (!isDrawing) {
      cov_1z2c2igzc5().b[8][0]++;
      cov_1z2c2igzc5().s[46]++;
      return;
    } else {
      cov_1z2c2igzc5().b[8][1]++;
    } // Allow only chosen pointer type


    cov_1z2c2igzc5().s[47]++;

    if ((cov_1z2c2igzc5().b[10][0]++, allowOnlyPointerType !== 'all') && (cov_1z2c2igzc5().b[10][1]++, event.pointerType !== allowOnlyPointerType)) {
      cov_1z2c2igzc5().b[9][0]++;
      cov_1z2c2igzc5().s[48]++;
      return;
    } else {
      cov_1z2c2igzc5().b[9][1]++;
    }

    var point = (cov_1z2c2igzc5().s[49]++, this.getCoordinates(event));
    cov_1z2c2igzc5().s[50]++;
    onPointerMove(point);
  };

  _proto.handlePointerUp = function handlePointerUp(event) {
    cov_1z2c2igzc5().f[11]++;
    cov_1z2c2igzc5().s[51]++;

    if ((cov_1z2c2igzc5().b[12][0]++, event.pointerType === 'mouse') && (cov_1z2c2igzc5().b[12][1]++, event.button !== 0)) {
      cov_1z2c2igzc5().b[11][0]++;
      cov_1z2c2igzc5().s[52]++;
      return;
    } else {
      cov_1z2c2igzc5().b[11][1]++;
    } // Allow only chosen pointer type


    var _ref5 = (cov_1z2c2igzc5().s[53]++, this.props),
        allowOnlyPointerType = _ref5.allowOnlyPointerType,
        onPointerUp = _ref5.onPointerUp;

    cov_1z2c2igzc5().s[54]++;

    if ((cov_1z2c2igzc5().b[14][0]++, allowOnlyPointerType !== 'all') && (cov_1z2c2igzc5().b[14][1]++, event.pointerType !== allowOnlyPointerType)) {
      cov_1z2c2igzc5().b[13][0]++;
      cov_1z2c2igzc5().s[55]++;
      return;
    } else {
      cov_1z2c2igzc5().b[13][1]++;
    }

    cov_1z2c2igzc5().s[56]++;
    onPointerUp();
  }
  /* Mouse Handlers ends */
  // Creates a image from SVG and renders it on canvas, then exports the canvas as image
  ;

  _proto.exportImage = function exportImage(imageType) {
    var _this2 = this;

    cov_1z2c2igzc5().f[12]++;
    cov_1z2c2igzc5().s[57]++;
    return new Promise( /*#__PURE__*/function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(resolve, reject) {
        var canvas, _ref7, backgroundImage, exportWithBackgroundImage, _ref8, svgCanvas, width, height, canvasSketch, loadImagePromises, img;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                cov_1z2c2igzc5().f[13]++;
                cov_1z2c2igzc5().s[58]++;
                _context.prev = 2;
                canvas = (cov_1z2c2igzc5().s[59]++, _this2.canvas.current);
                cov_1z2c2igzc5().s[60]++;

                if (canvas) {
                  _context.next = 11;
                  break;
                }

                cov_1z2c2igzc5().b[15][0]++;
                cov_1z2c2igzc5().s[61]++;
                throw Error('Canvas not rendered yet');

              case 11:
                cov_1z2c2igzc5().b[15][1]++;

              case 12:
                _ref7 = (cov_1z2c2igzc5().s[62]++, _this2.props), backgroundImage = _ref7.backgroundImage, exportWithBackgroundImage = _ref7.exportWithBackgroundImage;
                _ref8 = (cov_1z2c2igzc5().s[63]++, getCanvasWithViewBox(canvas)), svgCanvas = _ref8.svgCanvas, width = _ref8.width, height = _ref8.height;
                canvasSketch = (cov_1z2c2igzc5().s[64]++, "data:image/svg+xml;base64," + btoa(svgCanvas.outerHTML));
                cov_1z2c2igzc5().s[65]++;
                _context.next = 18;
                return loadImage(canvasSketch);

              case 18:
                _context.t0 = _context.sent;
                loadImagePromises = [_context.t0];
                cov_1z2c2igzc5().s[66]++;

                if (!exportWithBackgroundImage) {
                  _context.next = 39;
                  break;
                }

                cov_1z2c2igzc5().b[16][0]++;
                cov_1z2c2igzc5().s[67]++;
                _context.prev = 24;
                cov_1z2c2igzc5().s[68]++;
                _context.next = 28;
                return loadImage(backgroundImage);

              case 28:
                img = _context.sent;
                cov_1z2c2igzc5().s[69]++;
                loadImagePromises.push(img);
                _context.next = 37;
                break;

              case 33:
                _context.prev = 33;
                _context.t1 = _context["catch"](24);
                cov_1z2c2igzc5().s[70]++;
                console.warn('exportWithBackgroundImage props is set without a valid background image URL. This option is ignored');

              case 37:
                _context.next = 40;
                break;

              case 39:
                cov_1z2c2igzc5().b[16][1]++;

              case 40:
                cov_1z2c2igzc5().s[71]++;
                Promise.all(loadImagePromises).then(function (images) {
                  cov_1z2c2igzc5().f[14]++;
                  var renderCanvas = (cov_1z2c2igzc5().s[72]++, document.createElement('canvas'));
                  cov_1z2c2igzc5().s[73]++;
                  renderCanvas.setAttribute('width', width.toString());
                  cov_1z2c2igzc5().s[74]++;
                  renderCanvas.setAttribute('height', height.toString());
                  var context = (cov_1z2c2igzc5().s[75]++, renderCanvas.getContext('2d'));
                  cov_1z2c2igzc5().s[76]++;

                  if (!context) {
                    cov_1z2c2igzc5().b[17][0]++;
                    cov_1z2c2igzc5().s[77]++;
                    throw Error('Canvas not rendered yet');
                  } else {
                    cov_1z2c2igzc5().b[17][1]++;
                  }

                  cov_1z2c2igzc5().s[78]++;
                  images.reverse().forEach(function (image) {
                    cov_1z2c2igzc5().f[15]++;
                    cov_1z2c2igzc5().s[79]++;
                    context.drawImage(image, 0, 0);
                  });
                  cov_1z2c2igzc5().s[80]++;
                  resolve(renderCanvas.toDataURL("image/" + imageType));
                })["catch"](function (e) {
                  cov_1z2c2igzc5().f[16]++;
                  cov_1z2c2igzc5().s[81]++;
                  throw e;
                });
                _context.next = 48;
                break;

              case 44:
                _context.prev = 44;
                _context.t2 = _context["catch"](2);
                cov_1z2c2igzc5().s[82]++;
                reject(_context.t2);

              case 48:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[2, 44], [24, 33]]);
      }));

      return function (_x, _x2) {
        return _ref6.apply(this, arguments);
      };
    }());
  };

  _proto.exportSvg = function exportSvg() {
    var _this3 = this;

    cov_1z2c2igzc5().f[17]++;
    cov_1z2c2igzc5().s[83]++;
    return new Promise(function (resolve, reject) {
      cov_1z2c2igzc5().f[18]++;
      cov_1z2c2igzc5().s[84]++;

      try {
        var _ref9, _this3$canvas;

        var canvas = (cov_1z2c2igzc5().s[85]++, (_ref9 = (cov_1z2c2igzc5().b[18][0]++, (_this3$canvas = _this3.canvas) == null ? void 0 : _this3$canvas.current)) != null ? _ref9 : (cov_1z2c2igzc5().b[18][1]++, null));
        cov_1z2c2igzc5().s[86]++;

        if (canvas !== null) {
          var _svgCanvas$querySelec, _svgCanvas$querySelec2;

          cov_1z2c2igzc5().b[19][0]++;

          var _ref10 = (cov_1z2c2igzc5().s[87]++, getCanvasWithViewBox(canvas)),
              svgCanvas = _ref10.svgCanvas;

          var _ref11 = (cov_1z2c2igzc5().s[88]++, _this3.props),
              exportWithBackgroundImage = _ref11.exportWithBackgroundImage,
              canvasColor = _ref11.canvasColor;

          cov_1z2c2igzc5().s[89]++;

          if (exportWithBackgroundImage) {
            cov_1z2c2igzc5().b[20][0]++;
            cov_1z2c2igzc5().s[90]++;
            resolve(svgCanvas.outerHTML);
            cov_1z2c2igzc5().s[91]++;
            return;
          } else {
            cov_1z2c2igzc5().b[20][1]++;
          }

          cov_1z2c2igzc5().s[92]++;
          (_svgCanvas$querySelec = svgCanvas.querySelector('#background')) == null ? void 0 : _svgCanvas$querySelec.remove();
          cov_1z2c2igzc5().s[93]++;
          (_svgCanvas$querySelec2 = svgCanvas.querySelector('#canvas-background')) == null ? void 0 : _svgCanvas$querySelec2.setAttribute('fill', canvasColor);
          cov_1z2c2igzc5().s[94]++;
          resolve(svgCanvas.outerHTML);
        } else {
          cov_1z2c2igzc5().b[19][1]++;
        }

        cov_1z2c2igzc5().s[95]++;
        reject(new Error('Canvas not loaded'));
      } catch (e) {
        cov_1z2c2igzc5().s[96]++;
        reject(e);
      }
    });
  }
  /* Finally!!! Render method */
  ;

  _proto.render = function render() {
    cov_1z2c2igzc5().f[19]++;

    var _ref12 = (cov_1z2c2igzc5().s[97]++, this.props),
        width = _ref12.width,
        height = _ref12.height,
        className = _ref12.className,
        canvasColor = _ref12.canvasColor,
        backgroundImage = _ref12.backgroundImage,
        style = _ref12.style,
        paths = _ref12.paths,
        preserveBackgroundImageAspectRatio = _ref12.preserveBackgroundImageAspectRatio;

    var eraserPaths = (cov_1z2c2igzc5().s[98]++, paths.filter(function (path) {
      cov_1z2c2igzc5().f[20]++;
      cov_1z2c2igzc5().s[99]++;
      return !path.drawMode;
    }));
    var currentGroup = (cov_1z2c2igzc5().s[100]++, 0);
    var pathGroups = (cov_1z2c2igzc5().s[101]++, paths.reduce(function (arrayGroup, path) {
      cov_1z2c2igzc5().f[21]++;
      cov_1z2c2igzc5().s[102]++;

      if (!path.drawMode) {
        cov_1z2c2igzc5().b[21][0]++;
        cov_1z2c2igzc5().s[103]++;
        currentGroup += 1;
        cov_1z2c2igzc5().s[104]++;
        return arrayGroup;
      } else {
        cov_1z2c2igzc5().b[21][1]++;
      }

      cov_1z2c2igzc5().s[105]++;

      if (arrayGroup[currentGroup] === undefined) {
        cov_1z2c2igzc5().b[22][0]++;
        cov_1z2c2igzc5().s[106]++;
        arrayGroup[currentGroup] = [];
      } else {
        cov_1z2c2igzc5().b[22][1]++;
      }

      cov_1z2c2igzc5().s[107]++;
      arrayGroup[currentGroup].push(path);
      cov_1z2c2igzc5().s[108]++;
      return arrayGroup;
    }, [[]]));
    cov_1z2c2igzc5().s[109]++;
    return React__namespace.createElement("div", {
      role: "presentation",
      "aria-label": "react-sketch-canvas",
      ref: this.canvas,
      className: className,
      style: _extends({
        touchAction: 'none',
        width: width,
        height: height
      }, style),
      "touch-action": "none",
      onPointerDown: this.handlePointerDown,
      onPointerMove: this.handlePointerMove,
      onPointerUp: this.handlePointerUp
    }, React__namespace.createElement("svg", {
      version: "1.1",
      baseProfile: "full",
      xmlns: "http://www.w3.org/2000/svg",
      xmlnsXlink: "http://www.w3.org/1999/xlink",
      style: {
        width: '100%',
        height: '100%'
      }
    }, React__namespace.createElement("g", {
      id: "eraser-stroke-group",
      display: "none"
    }, React__namespace.createElement("rect", {
      id: "mask-background",
      x: "0",
      y: "0",
      width: "100%",
      height: "100%",
      fill: "white"
    }), eraserPaths.map(function (eraserPath, i) {
      cov_1z2c2igzc5().f[22]++;
      cov_1z2c2igzc5().s[110]++;
      return React__namespace.createElement(SvgPath, {
        key: "eraser-" + i,
        id: "eraser-" + i,
        paths: eraserPath.paths,
        strokeColor: "#000000",
        strokeWidth: eraserPath.strokeWidth
      });
    })), React__namespace.createElement("defs", null, (cov_1z2c2igzc5().b[23][0]++, backgroundImage) && (cov_1z2c2igzc5().b[23][1]++, React__namespace.createElement("pattern", {
      id: "background",
      x: "0",
      y: "0",
      width: "100%",
      height: "100%",
      patternUnits: "userSpaceOnUse"
    }, React__namespace.createElement("image", {
      x: "0",
      y: "0",
      width: "100%",
      height: "100%",
      xlinkHref: backgroundImage,
      preserveAspectRatio: preserveBackgroundImageAspectRatio
    }))), eraserPaths.map(function (_, i) {
      cov_1z2c2igzc5().f[23]++;
      cov_1z2c2igzc5().s[111]++;
      return React__namespace.createElement("mask", {
        id: "eraser-mask-" + i,
        key: "eraser-mask-" + i
      }, React__namespace.createElement("use", {
        href: "#mask-background"
      }), Array.from({
        length: eraserPaths.length - i
      }, function (_, j) {
        cov_1z2c2igzc5().f[24]++;
        cov_1z2c2igzc5().s[112]++;
        return j + i;
      }).map(function (k) {
        cov_1z2c2igzc5().f[25]++;
        cov_1z2c2igzc5().s[113]++;
        return React__namespace.createElement("use", {
          key: k.toString(),
          href: "#eraser-" + k.toString()
        });
      }));
    })), React__namespace.createElement("g", {
      id: "canvas-background-group"
    }, React__namespace.createElement("rect", {
      id: "canvas-background",
      x: "0",
      y: "0",
      width: "100%",
      height: "100%",
      fill: backgroundImage ? (cov_1z2c2igzc5().b[24][0]++, 'url(#background)') : (cov_1z2c2igzc5().b[24][1]++, canvasColor)
    })), pathGroups.map(function (pathGroup, i) {
      cov_1z2c2igzc5().f[26]++;
      cov_1z2c2igzc5().s[114]++;
      return React__namespace.createElement("g", {
        id: "stroke-group-" + i,
        key: "stroke-group-" + i,
        mask: "url(#eraser-mask-" + i + ")"
      }, React__namespace.createElement(Paths, {
        paths: pathGroup
      }));
    })));
  };

  return Canvas;
}((React__namespace.Component));
Canvas.defaultProps = ( cov_1z2c2igzc5().s[19]++, defaultProps$1);

function cov_1yx7tpadr3() {
  var path = "/home/vinoth/projects/react-sketch-canvas/src/ReactSketchCanvas/index.tsx";
  var hash = "ca0ffda71c644dfae79ade6dda809658d715ee05";
  var global = new Function("return this")();
  var gcv = "__coverage__";
  var coverageData = {
    path: "/home/vinoth/projects/react-sketch-canvas/src/ReactSketchCanvas/index.tsx",
    statementMap: {
      "0": {
        start: {
          line: 5,
          column: 21
        },
        end: {
          line: 24,
          column: 1
        }
      },
      "1": {
        start: {
          line: 26,
          column: 26
        },
        end: {
          line: 26,
          column: 38
        }
      },
      "2": {
        start: {
          line: 28,
          column: 19
        },
        end: {
          line: 35,
          column: 5
        }
      },
      "3": {
        start: {
          line: 37,
          column: 8
        },
        end: {
          line: 37,
          column: 21
        }
      },
      "4": {
        start: {
          line: 38,
          column: 8
        },
        end: {
          line: 38,
          column: 39
        }
      },
      "5": {
        start: {
          line: 39,
          column: 8
        },
        end: {
          line: 39,
          column: 67
        }
      },
      "6": {
        start: {
          line: 40,
          column: 8
        },
        end: {
          line: 40,
          column: 67
        }
      },
      "7": {
        start: {
          line: 41,
          column: 8
        },
        end: {
          line: 41,
          column: 63
        }
      },
      "8": {
        start: {
          line: 42,
          column: 8
        },
        end: {
          line: 42,
          column: 55
        }
      },
      "9": {
        start: {
          line: 43,
          column: 8
        },
        end: {
          line: 43,
          column: 51
        }
      },
      "10": {
        start: {
          line: 44,
          column: 8
        },
        end: {
          line: 44,
          column: 55
        }
      },
      "11": {
        start: {
          line: 45,
          column: 8
        },
        end: {
          line: 45,
          column: 51
        }
      },
      "12": {
        start: {
          line: 46,
          column: 8
        },
        end: {
          line: 46,
          column: 51
        }
      },
      "13": {
        start: {
          line: 47,
          column: 8
        },
        end: {
          line: 47,
          column: 55
        }
      },
      "14": {
        start: {
          line: 48,
          column: 8
        },
        end: {
          line: 48,
          column: 41
        }
      },
      "15": {
        start: {
          line: 49,
          column: 8
        },
        end: {
          line: 49,
          column: 41
        }
      },
      "16": {
        start: {
          line: 50,
          column: 8
        },
        end: {
          line: 50,
          column: 55
        }
      },
      "17": {
        start: {
          line: 51,
          column: 8
        },
        end: {
          line: 51,
          column: 65
        }
      },
      "18": {
        start: {
          line: 52,
          column: 8
        },
        end: {
          line: 52,
          column: 55
        }
      },
      "19": {
        start: {
          line: 53,
          column: 8
        },
        end: {
          line: 53,
          column: 57
        }
      },
      "20": {
        start: {
          line: 54,
          column: 8
        },
        end: {
          line: 54,
          column: 43
        }
      },
      "21": {
        start: {
          line: 57,
          column: 34
        },
        end: {
          line: 57,
          column: 44
        }
      },
      "22": {
        start: {
          line: 58,
          column: 33
        },
        end: {
          line: 58,
          column: 43
        }
      },
      "23": {
        start: {
          line: 59,
          column: 8
        },
        end: {
          line: 74,
          column: 11
        }
      },
      "24": {
        start: {
          line: 60,
          column: 12
        },
        end: {
          line: 62,
          column: 13
        }
      },
      "25": {
        start: {
          line: 61,
          column: 16
        },
        end: {
          line: 61,
          column: 84
        }
      },
      "26": {
        start: {
          line: 63,
          column: 12
        },
        end: {
          line: 73,
          column: 13
        }
      },
      "27": {
        start: {
          line: 64,
          column: 38
        },
        end: {
          line: 68,
          column: 21
        }
      },
      "28": {
        start: {
          line: 65,
          column: 43
        },
        end: {
          line: 65,
          column: 67
        }
      },
      "29": {
        start: {
          line: 66,
          column: 41
        },
        end: {
          line: 66,
          column: 63
        }
      },
      "30": {
        start: {
          line: 67,
          column: 20
        },
        end: {
          line: 67,
          column: 80
        }
      },
      "31": {
        start: {
          line: 69,
          column: 16
        },
        end: {
          line: 69,
          column: 39
        }
      },
      "32": {
        start: {
          line: 72,
          column: 16
        },
        end: {
          line: 72,
          column: 26
        }
      },
      "33": {
        start: {
          line: 77,
          column: 8
        },
        end: {
          line: 77,
          column: 48
        }
      },
      "34": {
        start: {
          line: 80,
          column: 33
        },
        end: {
          line: 80,
          column: 43
        }
      },
      "35": {
        start: {
          line: 81,
          column: 29
        },
        end: {
          line: 81,
          column: 39
        }
      },
      "36": {
        start: {
          line: 82,
          column: 8
        },
        end: {
          line: 82,
          column: 31
        }
      },
      "37": {
        start: {
          line: 85,
          column: 33
        },
        end: {
          line: 85,
          column: 43
        }
      },
      "38": {
        start: {
          line: 86,
          column: 29
        },
        end: {
          line: 86,
          column: 39
        }
      },
      "39": {
        start: {
          line: 87,
          column: 27
        },
        end: {
          line: 87,
          column: 46
        }
      },
      "40": {
        start: {
          line: 88,
          column: 8
        },
        end: {
          line: 91,
          column: 9
        }
      },
      "41": {
        start: {
          line: 89,
          column: 12
        },
        end: {
          line: 89,
          column: 45
        }
      },
      "42": {
        start: {
          line: 90,
          column: 12
        },
        end: {
          line: 90,
          column: 19
        }
      },
      "43": {
        start: {
          line: 92,
          column: 8
        },
        end: {
          line: 92,
          column: 51
        }
      },
      "44": {
        start: {
          line: 96,
          column: 73
        },
        end: {
          line: 96,
          column: 83
        }
      },
      "45": {
        start: {
          line: 97,
          column: 8
        },
        end: {
          line: 114,
          column: 30
        }
      },
      "46": {
        start: {
          line: 98,
          column: 12
        },
        end: {
          line: 98,
          column: 35
        }
      },
      "47": {
        start: {
          line: 99,
          column: 12
        },
        end: {
          line: 99,
          column: 33
        }
      },
      "48": {
        start: {
          line: 100,
          column: 25
        },
        end: {
          line: 105,
          column: 13
        }
      },
      "49": {
        start: {
          line: 106,
          column: 12
        },
        end: {
          line: 112,
          column: 13
        }
      },
      "50": {
        start: {
          line: 107,
          column: 16
        },
        end: {
          line: 111,
          column: 18
        }
      },
      "51": {
        start: {
          line: 113,
          column: 12
        },
        end: {
          line: 113,
          column: 44
        }
      },
      "52": {
        start: {
          line: 117,
          column: 30
        },
        end: {
          line: 117,
          column: 40
        }
      },
      "53": {
        start: {
          line: 118,
          column: 8
        },
        end: {
          line: 119,
          column: 19
        }
      },
      "54": {
        start: {
          line: 119,
          column: 12
        },
        end: {
          line: 119,
          column: 19
        }
      },
      "55": {
        start: {
          line: 120,
          column: 8
        },
        end: {
          line: 123,
          column: 30
        }
      },
      "56": {
        start: {
          line: 121,
          column: 34
        },
        end: {
          line: 121,
          column: 83
        }
      },
      "57": {
        start: {
          line: 122,
          column: 12
        },
        end: {
          line: 122,
          column: 44
        }
      },
      "58": {
        start: {
          line: 126,
          column: 34
        },
        end: {
          line: 126,
          column: 44
        }
      },
      "59": {
        start: {
          line: 127,
          column: 30
        },
        end: {
          line: 127,
          column: 40
        }
      },
      "60": {
        start: {
          line: 128,
          column: 8
        },
        end: {
          line: 130,
          column: 9
        }
      },
      "61": {
        start: {
          line: 129,
          column: 12
        },
        end: {
          line: 129,
          column: 19
        }
      },
      "62": {
        start: {
          line: 131,
          column: 8
        },
        end: {
          line: 147,
          column: 11
        }
      },
      "63": {
        start: {
          line: 132,
          column: 12
        },
        end: {
          line: 132,
          column: 36
        }
      },
      "64": {
        start: {
          line: 133,
          column: 12
        },
        end: {
          line: 135,
          column: 13
        }
      },
      "65": {
        start: {
          line: 134,
          column: 16
        },
        end: {
          line: 134,
          column: 23
        }
      },
      "66": {
        start: {
          line: 136,
          column: 32
        },
        end: {
          line: 136,
          column: 56
        }
      },
      "67": {
        start: {
          line: 137,
          column: 12
        },
        end: {
          line: 143,
          column: 13
        }
      },
      "68": {
        start: {
          line: 138,
          column: 16
        },
        end: {
          line: 141,
          column: 18
        }
      },
      "69": {
        start: {
          line: 142,
          column: 16
        },
        end: {
          line: 142,
          column: 55
        }
      },
      "70": {
        start: {
          line: 145,
          column: 12
        },
        end: {
          line: 145,
          column: 31
        }
      },
      "71": {
        start: {
          line: 146,
          column: 12
        },
        end: {
          line: 146,
          column: 32
        }
      },
      "72": {
        start: {
          line: 152,
          column: 8
        },
        end: {
          line: 154,
          column: 30
        }
      },
      "73": {
        start: {
          line: 153,
          column: 12
        },
        end: {
          line: 153,
          column: 36
        }
      },
      "74": {
        start: {
          line: 157,
          column: 8
        },
        end: {
          line: 160,
          column: 30
        }
      },
      "75": {
        start: {
          line: 158,
          column: 12
        },
        end: {
          line: 158,
          column: 50
        }
      },
      "76": {
        start: {
          line: 159,
          column: 12
        },
        end: {
          line: 159,
          column: 36
        }
      },
      "77": {
        start: {
          line: 163,
          column: 31
        },
        end: {
          line: 163,
          column: 41
        }
      },
      "78": {
        start: {
          line: 165,
          column: 8
        },
        end: {
          line: 171,
          column: 9
        }
      },
      "79": {
        start: {
          line: 166,
          column: 12
        },
        end: {
          line: 169,
          column: 34
        }
      },
      "80": {
        start: {
          line: 167,
          column: 16
        },
        end: {
          line: 167,
          column: 54
        }
      },
      "81": {
        start: {
          line: 168,
          column: 16
        },
        end: {
          line: 168,
          column: 38
        }
      },
      "82": {
        start: {
          line: 170,
          column: 12
        },
        end: {
          line: 170,
          column: 19
        }
      },
      "83": {
        start: {
          line: 172,
          column: 8
        },
        end: {
          line: 177,
          column: 30
        }
      },
      "84": {
        start: {
          line: 173,
          column: 35
        },
        end: {
          line: 173,
          column: 59
        }
      },
      "85": {
        start: {
          line: 174,
          column: 12
        },
        end: {
          line: 176,
          column: 13
        }
      },
      "86": {
        start: {
          line: 175,
          column: 16
        },
        end: {
          line: 175,
          column: 53
        }
      },
      "87": {
        start: {
          line: 180,
          column: 30
        },
        end: {
          line: 180,
          column: 40
        }
      },
      "88": {
        start: {
          line: 182,
          column: 8
        },
        end: {
          line: 183,
          column: 19
        }
      },
      "89": {
        start: {
          line: 183,
          column: 12
        },
        end: {
          line: 183,
          column: 19
        }
      },
      "90": {
        start: {
          line: 184,
          column: 8
        },
        end: {
          line: 189,
          column: 30
        }
      },
      "91": {
        start: {
          line: 185,
          column: 33
        },
        end: {
          line: 185,
          column: 54
        }
      },
      "92": {
        start: {
          line: 186,
          column: 12
        },
        end: {
          line: 188,
          column: 13
        }
      },
      "93": {
        start: {
          line: 187,
          column: 16
        },
        end: {
          line: 187,
          column: 54
        }
      },
      "94": {
        start: {
          line: 194,
          column: 28
        },
        end: {
          line: 194,
          column: 63
        }
      },
      "95": {
        start: {
          line: 195,
          column: 8
        },
        end: {
          line: 200,
          column: 9
        }
      },
      "96": {
        start: {
          line: 196,
          column: 12
        },
        end: {
          line: 196,
          column: 71
        }
      },
      "97": {
        start: {
          line: 199,
          column: 12
        },
        end: {
          line: 199,
          column: 42
        }
      },
      "98": {
        start: {
          line: 203,
          column: 8
        },
        end: {
          line: 217,
          column: 11
        }
      },
      "99": {
        start: {
          line: 204,
          column: 30
        },
        end: {
          line: 204,
          column: 63
        }
      },
      "100": {
        start: {
          line: 205,
          column: 12
        },
        end: {
          line: 216,
          column: 13
        }
      },
      "101": {
        start: {
          line: 206,
          column: 16
        },
        end: {
          line: 206,
          column: 77
        }
      },
      "102": {
        start: {
          line: 209,
          column: 16
        },
        end: {
          line: 215,
          column: 19
        }
      },
      "103": {
        start: {
          line: 211,
          column: 20
        },
        end: {
          line: 211,
          column: 34
        }
      },
      "104": {
        start: {
          line: 214,
          column: 20
        },
        end: {
          line: 214,
          column: 30
        }
      },
      "105": {
        start: {
          line: 220,
          column: 33
        },
        end: {
          line: 220,
          column: 43
        }
      },
      "106": {
        start: {
          line: 221,
          column: 8
        },
        end: {
          line: 228,
          column: 11
        }
      },
      "107": {
        start: {
          line: 222,
          column: 12
        },
        end: {
          line: 227,
          column: 13
        }
      },
      "108": {
        start: {
          line: 223,
          column: 16
        },
        end: {
          line: 223,
          column: 38
        }
      },
      "109": {
        start: {
          line: 226,
          column: 16
        },
        end: {
          line: 226,
          column: 26
        }
      },
      "110": {
        start: {
          line: 231,
          column: 8
        },
        end: {
          line: 233,
          column: 30
        }
      },
      "111": {
        start: {
          line: 232,
          column: 12
        },
        end: {
          line: 232,
          column: 66
        }
      },
      "112": {
        start: {
          line: 237,
          column: 168
        },
        end: {
          line: 237,
          column: 178
        }
      },
      "113": {
        start: {
          line: 238,
          column: 44
        },
        end: {
          line: 238,
          column: 54
        }
      },
      "114": {
        start: {
          line: 239,
          column: 8
        },
        end: {
          line: 239,
          column: 522
        }
      }
    },
    fnMap: {
      "0": {
        name: "(anonymous_0)",
        decl: {
          start: {
            line: 21,
            column: 14
          },
          end: {
            line: 21,
            column: 15
          }
        },
        loc: {
          start: {
            line: 21,
            column: 26
          },
          end: {
            line: 21,
            column: 29
          }
        },
        line: 21
      },
      "1": {
        name: "(anonymous_1)",
        decl: {
          start: {
            line: 22,
            column: 14
          },
          end: {
            line: 22,
            column: 15
          }
        },
        loc: {
          start: {
            line: 22,
            column: 36
          },
          end: {
            line: 22,
            column: 39
          }
        },
        line: 22
      },
      "2": {
        name: "(anonymous_2)",
        decl: {
          start: {
            line: 36,
            column: 4
          },
          end: {
            line: 36,
            column: 5
          }
        },
        loc: {
          start: {
            line: 36,
            column: 23
          },
          end: {
            line: 55,
            column: 5
          }
        },
        line: 36
      },
      "3": {
        name: "(anonymous_3)",
        decl: {
          start: {
            line: 56,
            column: 4
          },
          end: {
            line: 56,
            column: 5
          }
        },
        loc: {
          start: {
            line: 56,
            column: 23
          },
          end: {
            line: 75,
            column: 5
          }
        },
        line: 56
      },
      "4": {
        name: "(anonymous_4)",
        decl: {
          start: {
            line: 59,
            column: 27
          },
          end: {
            line: 59,
            column: 28
          }
        },
        loc: {
          start: {
            line: 59,
            column: 48
          },
          end: {
            line: 74,
            column: 9
          }
        },
        line: 59
      },
      "5": {
        name: "(anonymous_5)",
        decl: {
          start: {
            line: 64,
            column: 58
          },
          end: {
            line: 64,
            column: 59
          }
        },
        loc: {
          start: {
            line: 64,
            column: 88
          },
          end: {
            line: 68,
            column: 17
          }
        },
        line: 64
      },
      "6": {
        name: "(anonymous_6)",
        decl: {
          start: {
            line: 76,
            column: 4
          },
          end: {
            line: 76,
            column: 5
          }
        },
        loc: {
          start: {
            line: 76,
            column: 18
          },
          end: {
            line: 78,
            column: 5
          }
        },
        line: 76
      },
      "7": {
        name: "(anonymous_7)",
        decl: {
          start: {
            line: 79,
            column: 4
          },
          end: {
            line: 79,
            column: 5
          }
        },
        loc: {
          start: {
            line: 79,
            column: 18
          },
          end: {
            line: 83,
            column: 5
          }
        },
        line: 79
      },
      "8": {
        name: "(anonymous_8)",
        decl: {
          start: {
            line: 84,
            column: 4
          },
          end: {
            line: 84,
            column: 5
          }
        },
        loc: {
          start: {
            line: 84,
            column: 19
          },
          end: {
            line: 93,
            column: 5
          }
        },
        line: 84
      },
      "9": {
        name: "(anonymous_9)",
        decl: {
          start: {
            line: 95,
            column: 4
          },
          end: {
            line: 95,
            column: 5
          }
        },
        loc: {
          start: {
            line: 95,
            column: 29
          },
          end: {
            line: 115,
            column: 5
          }
        },
        line: 95
      },
      "10": {
        name: "(anonymous_10)",
        decl: {
          start: {
            line: 97,
            column: 30
          },
          end: {
            line: 97,
            column: 31
          }
        },
        loc: {
          start: {
            line: 97,
            column: 41
          },
          end: {
            line: 114,
            column: 9
          }
        },
        line: 97
      },
      "11": {
        name: "(anonymous_11)",
        decl: {
          start: {
            line: 116,
            column: 4
          },
          end: {
            line: 116,
            column: 5
          }
        },
        loc: {
          start: {
            line: 116,
            column: 29
          },
          end: {
            line: 124,
            column: 5
          }
        },
        line: 116
      },
      "12": {
        name: "(anonymous_12)",
        decl: {
          start: {
            line: 120,
            column: 30
          },
          end: {
            line: 120,
            column: 31
          }
        },
        loc: {
          start: {
            line: 120,
            column: 41
          },
          end: {
            line: 123,
            column: 9
          }
        },
        line: 120
      },
      "13": {
        name: "(anonymous_13)",
        decl: {
          start: {
            line: 125,
            column: 4
          },
          end: {
            line: 125,
            column: 5
          }
        },
        loc: {
          start: {
            line: 125,
            column: 22
          },
          end: {
            line: 148,
            column: 5
          }
        },
        line: 125
      },
      "14": {
        name: "(anonymous_14)",
        decl: {
          start: {
            line: 131,
            column: 30
          },
          end: {
            line: 131,
            column: 31
          }
        },
        loc: {
          start: {
            line: 131,
            column: 41
          },
          end: {
            line: 144,
            column: 9
          }
        },
        line: 131
      },
      "15": {
        name: "(anonymous_15)",
        decl: {
          start: {
            line: 144,
            column: 12
          },
          end: {
            line: 144,
            column: 13
          }
        },
        loc: {
          start: {
            line: 144,
            column: 18
          },
          end: {
            line: 147,
            column: 9
          }
        },
        line: 144
      },
      "16": {
        name: "(anonymous_16)",
        decl: {
          start: {
            line: 151,
            column: 4
          },
          end: {
            line: 151,
            column: 5
          }
        },
        loc: {
          start: {
            line: 151,
            column: 21
          },
          end: {
            line: 155,
            column: 5
          }
        },
        line: 151
      },
      "17": {
        name: "(anonymous_17)",
        decl: {
          start: {
            line: 152,
            column: 30
          },
          end: {
            line: 152,
            column: 31
          }
        },
        loc: {
          start: {
            line: 152,
            column: 41
          },
          end: {
            line: 154,
            column: 9
          }
        },
        line: 152
      },
      "18": {
        name: "(anonymous_18)",
        decl: {
          start: {
            line: 156,
            column: 4
          },
          end: {
            line: 156,
            column: 5
          }
        },
        loc: {
          start: {
            line: 156,
            column: 18
          },
          end: {
            line: 161,
            column: 5
          }
        },
        line: 156
      },
      "19": {
        name: "(anonymous_19)",
        decl: {
          start: {
            line: 157,
            column: 30
          },
          end: {
            line: 157,
            column: 31
          }
        },
        loc: {
          start: {
            line: 157,
            column: 41
          },
          end: {
            line: 160,
            column: 9
          }
        },
        line: 157
      },
      "20": {
        name: "(anonymous_20)",
        decl: {
          start: {
            line: 162,
            column: 4
          },
          end: {
            line: 162,
            column: 5
          }
        },
        loc: {
          start: {
            line: 162,
            column: 11
          },
          end: {
            line: 178,
            column: 5
          }
        },
        line: 162
      },
      "21": {
        name: "(anonymous_21)",
        decl: {
          start: {
            line: 166,
            column: 34
          },
          end: {
            line: 166,
            column: 35
          }
        },
        loc: {
          start: {
            line: 166,
            column: 45
          },
          end: {
            line: 169,
            column: 13
          }
        },
        line: 166
      },
      "22": {
        name: "(anonymous_22)",
        decl: {
          start: {
            line: 172,
            column: 30
          },
          end: {
            line: 172,
            column: 31
          }
        },
        loc: {
          start: {
            line: 172,
            column: 41
          },
          end: {
            line: 177,
            column: 9
          }
        },
        line: 172
      },
      "23": {
        name: "(anonymous_23)",
        decl: {
          start: {
            line: 179,
            column: 4
          },
          end: {
            line: 179,
            column: 5
          }
        },
        loc: {
          start: {
            line: 179,
            column: 11
          },
          end: {
            line: 190,
            column: 5
          }
        },
        line: 179
      },
      "24": {
        name: "(anonymous_24)",
        decl: {
          start: {
            line: 184,
            column: 30
          },
          end: {
            line: 184,
            column: 31
          }
        },
        loc: {
          start: {
            line: 184,
            column: 41
          },
          end: {
            line: 189,
            column: 9
          }
        },
        line: 184
      },
      "25": {
        name: "(anonymous_25)",
        decl: {
          start: {
            line: 193,
            column: 4
          },
          end: {
            line: 193,
            column: 5
          }
        },
        loc: {
          start: {
            line: 193,
            column: 27
          },
          end: {
            line: 201,
            column: 5
          }
        },
        line: 193
      },
      "26": {
        name: "(anonymous_26)",
        decl: {
          start: {
            line: 202,
            column: 4
          },
          end: {
            line: 202,
            column: 5
          }
        },
        loc: {
          start: {
            line: 202,
            column: 16
          },
          end: {
            line: 218,
            column: 5
          }
        },
        line: 202
      },
      "27": {
        name: "(anonymous_27)",
        decl: {
          start: {
            line: 203,
            column: 27
          },
          end: {
            line: 203,
            column: 28
          }
        },
        loc: {
          start: {
            line: 203,
            column: 48
          },
          end: {
            line: 217,
            column: 9
          }
        },
        line: 203
      },
      "28": {
        name: "(anonymous_28)",
        decl: {
          start: {
            line: 210,
            column: 26
          },
          end: {
            line: 210,
            column: 27
          }
        },
        loc: {
          start: {
            line: 210,
            column: 36
          },
          end: {
            line: 212,
            column: 17
          }
        },
        line: 210
      },
      "29": {
        name: "(anonymous_29)",
        decl: {
          start: {
            line: 213,
            column: 27
          },
          end: {
            line: 213,
            column: 28
          }
        },
        loc: {
          start: {
            line: 213,
            column: 34
          },
          end: {
            line: 215,
            column: 17
          }
        },
        line: 213
      },
      "30": {
        name: "(anonymous_30)",
        decl: {
          start: {
            line: 219,
            column: 4
          },
          end: {
            line: 219,
            column: 5
          }
        },
        loc: {
          start: {
            line: 219,
            column: 18
          },
          end: {
            line: 229,
            column: 5
          }
        },
        line: 219
      },
      "31": {
        name: "(anonymous_31)",
        decl: {
          start: {
            line: 221,
            column: 27
          },
          end: {
            line: 221,
            column: 28
          }
        },
        loc: {
          start: {
            line: 221,
            column: 48
          },
          end: {
            line: 228,
            column: 9
          }
        },
        line: 221
      },
      "32": {
        name: "(anonymous_32)",
        decl: {
          start: {
            line: 230,
            column: 4
          },
          end: {
            line: 230,
            column: 5
          }
        },
        loc: {
          start: {
            line: 230,
            column: 21
          },
          end: {
            line: 234,
            column: 5
          }
        },
        line: 230
      },
      "33": {
        name: "(anonymous_33)",
        decl: {
          start: {
            line: 231,
            column: 30
          },
          end: {
            line: 231,
            column: 31
          }
        },
        loc: {
          start: {
            line: 231,
            column: 41
          },
          end: {
            line: 233,
            column: 9
          }
        },
        line: 231
      },
      "34": {
        name: "(anonymous_34)",
        decl: {
          start: {
            line: 236,
            column: 4
          },
          end: {
            line: 236,
            column: 5
          }
        },
        loc: {
          start: {
            line: 236,
            column: 13
          },
          end: {
            line: 240,
            column: 5
          }
        },
        line: 236
      }
    },
    branchMap: {
      "0": {
        loc: {
          start: {
            line: 60,
            column: 12
          },
          end: {
            line: 62,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 60,
            column: 12
          },
          end: {
            line: 62,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 60
      },
      "1": {
        loc: {
          start: {
            line: 65,
            column: 43
          },
          end: {
            line: 65,
            column: 67
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 65,
            column: 43
          },
          end: {
            line: 65,
            column: 62
          }
        }, {
          start: {
            line: 65,
            column: 66
          },
          end: {
            line: 65,
            column: 67
          }
        }],
        line: 65
      },
      "2": {
        loc: {
          start: {
            line: 66,
            column: 41
          },
          end: {
            line: 66,
            column: 63
          }
        },
        type: "binary-expr",
        locations: [{
          start: {
            line: 66,
            column: 41
          },
          end: {
            line: 66,
            column: 58
          }
        }, {
          start: {
            line: 66,
            column: 62
          },
          end: {
            line: 66,
            column: 63
          }
        }],
        line: 66
      },
      "3": {
        loc: {
          start: {
            line: 88,
            column: 8
          },
          end: {
            line: 91,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 88,
            column: 8
          },
          end: {
            line: 91,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 88
      },
      "4": {
        loc: {
          start: {
            line: 102,
            column: 29
          },
          end: {
            line: 102,
            column: 69
          }
        },
        type: "cond-expr",
        locations: [{
          start: {
            line: 102,
            column: 46
          },
          end: {
            line: 102,
            column: 57
          }
        }, {
          start: {
            line: 102,
            column: 60
          },
          end: {
            line: 102,
            column: 69
          }
        }],
        line: 102
      },
      "5": {
        loc: {
          start: {
            line: 103,
            column: 29
          },
          end: {
            line: 103,
            column: 71
          }
        },
        type: "cond-expr",
        locations: [{
          start: {
            line: 103,
            column: 46
          },
          end: {
            line: 103,
            column: 57
          }
        }, {
          start: {
            line: 103,
            column: 60
          },
          end: {
            line: 103,
            column: 71
          }
        }],
        line: 103
      },
      "6": {
        loc: {
          start: {
            line: 106,
            column: 12
          },
          end: {
            line: 112,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 106,
            column: 12
          },
          end: {
            line: 112,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 106
      },
      "7": {
        loc: {
          start: {
            line: 118,
            column: 8
          },
          end: {
            line: 119,
            column: 19
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 118,
            column: 8
          },
          end: {
            line: 119,
            column: 19
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 118
      },
      "8": {
        loc: {
          start: {
            line: 128,
            column: 8
          },
          end: {
            line: 130,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 128,
            column: 8
          },
          end: {
            line: 130,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 128
      },
      "9": {
        loc: {
          start: {
            line: 133,
            column: 12
          },
          end: {
            line: 135,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 133,
            column: 12
          },
          end: {
            line: 135,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 133
      },
      "10": {
        loc: {
          start: {
            line: 137,
            column: 12
          },
          end: {
            line: 143,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 137,
            column: 12
          },
          end: {
            line: 143,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 137
      },
      "11": {
        loc: {
          start: {
            line: 165,
            column: 8
          },
          end: {
            line: 171,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 165,
            column: 8
          },
          end: {
            line: 171,
            column: 9
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 165
      },
      "12": {
        loc: {
          start: {
            line: 174,
            column: 12
          },
          end: {
            line: 176,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 174,
            column: 12
          },
          end: {
            line: 176,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 174
      },
      "13": {
        loc: {
          start: {
            line: 182,
            column: 8
          },
          end: {
            line: 183,
            column: 19
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 182,
            column: 8
          },
          end: {
            line: 183,
            column: 19
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 182
      },
      "14": {
        loc: {
          start: {
            line: 186,
            column: 12
          },
          end: {
            line: 188,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 186,
            column: 12
          },
          end: {
            line: 188,
            column: 13
          }
        }, {
          start: {
            line: undefined,
            column: undefined
          },
          end: {
            line: undefined,
            column: undefined
          }
        }],
        line: 186
      },
      "15": {
        loc: {
          start: {
            line: 195,
            column: 8
          },
          end: {
            line: 200,
            column: 9
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 195,
            column: 8
          },
          end: {
            line: 200,
            column: 9
          }
        }, {
          start: {
            line: 198,
            column: 13
          },
          end: {
            line: 200,
            column: 9
          }
        }],
        line: 195
      },
      "16": {
        loc: {
          start: {
            line: 205,
            column: 12
          },
          end: {
            line: 216,
            column: 13
          }
        },
        type: "if",
        locations: [{
          start: {
            line: 205,
            column: 12
          },
          end: {
            line: 216,
            column: 13
          }
        }, {
          start: {
            line: 208,
            column: 17
          },
          end: {
            line: 216,
            column: 13
          }
        }],
        line: 205
      }
    },
    s: {
      "0": 0,
      "1": 0,
      "2": 0,
      "3": 0,
      "4": 0,
      "5": 0,
      "6": 0,
      "7": 0,
      "8": 0,
      "9": 0,
      "10": 0,
      "11": 0,
      "12": 0,
      "13": 0,
      "14": 0,
      "15": 0,
      "16": 0,
      "17": 0,
      "18": 0,
      "19": 0,
      "20": 0,
      "21": 0,
      "22": 0,
      "23": 0,
      "24": 0,
      "25": 0,
      "26": 0,
      "27": 0,
      "28": 0,
      "29": 0,
      "30": 0,
      "31": 0,
      "32": 0,
      "33": 0,
      "34": 0,
      "35": 0,
      "36": 0,
      "37": 0,
      "38": 0,
      "39": 0,
      "40": 0,
      "41": 0,
      "42": 0,
      "43": 0,
      "44": 0,
      "45": 0,
      "46": 0,
      "47": 0,
      "48": 0,
      "49": 0,
      "50": 0,
      "51": 0,
      "52": 0,
      "53": 0,
      "54": 0,
      "55": 0,
      "56": 0,
      "57": 0,
      "58": 0,
      "59": 0,
      "60": 0,
      "61": 0,
      "62": 0,
      "63": 0,
      "64": 0,
      "65": 0,
      "66": 0,
      "67": 0,
      "68": 0,
      "69": 0,
      "70": 0,
      "71": 0,
      "72": 0,
      "73": 0,
      "74": 0,
      "75": 0,
      "76": 0,
      "77": 0,
      "78": 0,
      "79": 0,
      "80": 0,
      "81": 0,
      "82": 0,
      "83": 0,
      "84": 0,
      "85": 0,
      "86": 0,
      "87": 0,
      "88": 0,
      "89": 0,
      "90": 0,
      "91": 0,
      "92": 0,
      "93": 0,
      "94": 0,
      "95": 0,
      "96": 0,
      "97": 0,
      "98": 0,
      "99": 0,
      "100": 0,
      "101": 0,
      "102": 0,
      "103": 0,
      "104": 0,
      "105": 0,
      "106": 0,
      "107": 0,
      "108": 0,
      "109": 0,
      "110": 0,
      "111": 0,
      "112": 0,
      "113": 0,
      "114": 0
    },
    f: {
      "0": 0,
      "1": 0,
      "2": 0,
      "3": 0,
      "4": 0,
      "5": 0,
      "6": 0,
      "7": 0,
      "8": 0,
      "9": 0,
      "10": 0,
      "11": 0,
      "12": 0,
      "13": 0,
      "14": 0,
      "15": 0,
      "16": 0,
      "17": 0,
      "18": 0,
      "19": 0,
      "20": 0,
      "21": 0,
      "22": 0,
      "23": 0,
      "24": 0,
      "25": 0,
      "26": 0,
      "27": 0,
      "28": 0,
      "29": 0,
      "30": 0,
      "31": 0,
      "32": 0,
      "33": 0,
      "34": 0
    },
    b: {
      "0": [0, 0],
      "1": [0, 0],
      "2": [0, 0],
      "3": [0, 0],
      "4": [0, 0],
      "5": [0, 0],
      "6": [0, 0],
      "7": [0, 0],
      "8": [0, 0],
      "9": [0, 0],
      "10": [0, 0],
      "11": [0, 0],
      "12": [0, 0],
      "13": [0, 0],
      "14": [0, 0],
      "15": [0, 0],
      "16": [0, 0]
    },
    _coverageSchema: "1a1c01bbd47fc00a2c39e90264f33305004495a9",
    hash: "ca0ffda71c644dfae79ade6dda809658d715ee05"
  };
  var coverage = global[gcv] || (global[gcv] = {});

  if (!coverage[path] || coverage[path].hash !== hash) {
    coverage[path] = coverageData;
  }

  var actualCoverage = coverage[path];
  {
    // @ts-ignore
    cov_1yx7tpadr3 = function () {
      return actualCoverage;
    };
  }
  return actualCoverage;
}

cov_1yx7tpadr3();
/* Default settings */

var defaultProps = ( cov_1yx7tpadr3().s[0]++, {
  width: '100%',
  height: '100%',
  className: '',
  canvasColor: 'white',
  strokeColor: 'red',
  backgroundImage: '',
  exportWithBackgroundImage: true,
  preserveBackgroundImageAspectRatio: 'none',
  strokeWidth: 4,
  eraserWidth: 8,
  allowOnlyPointerType: 'all',
  style: {
    border: '0.0625rem solid #9c9c9c',
    borderRadius: '0.25rem'
  },
  onChange: function onChange(_paths) {
    cov_1yx7tpadr3().f[0]++;
  },
  onStroke: function onStroke(_path, _isEraser) {
    cov_1yx7tpadr3().f[1]++;
  },
  withTimestamp: false
});
var ReactSketchCanvas = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ReactSketchCanvas, _React$Component);

  function ReactSketchCanvas(props) {
    var _this;

    cov_1yx7tpadr3().f[2]++;
    cov_1yx7tpadr3().s[3]++;
    _this = _React$Component.call(this, props) || this;
    _this.svgCanvas = void 0;
    _this.initialState = (cov_1yx7tpadr3().s[2]++, {
      drawMode: true,
      isDrawing: false,
      // eslint-disable-next-line react/no-unused-state
      resetStack: [],
      undoStack: [],
      currentPaths: []
    });
    cov_1yx7tpadr3().s[4]++;
    _this.state = _this.initialState;
    cov_1yx7tpadr3().s[5]++;
    _this.handlePointerDown = _this.handlePointerDown.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[6]++;
    _this.handlePointerMove = _this.handlePointerMove.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[7]++;
    _this.handlePointerUp = _this.handlePointerUp.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[8]++;
    _this.exportImage = _this.exportImage.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[9]++;
    _this.exportSvg = _this.exportSvg.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[10]++;
    _this.exportPaths = _this.exportPaths.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[11]++;
    _this.loadPaths = _this.loadPaths.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[12]++;
    _this.eraseMode = _this.eraseMode.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[13]++;
    _this.clearCanvas = _this.clearCanvas.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[14]++;
    _this.undo = _this.undo.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[15]++;
    _this.redo = _this.redo.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[16]++;
    _this.resetCanvas = _this.resetCanvas.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[17]++;
    _this.getSketchingTime = _this.getSketchingTime.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[18]++;
    _this.liftPathsUp = _this.liftPathsUp.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[19]++;
    _this.liftStrokeUp = _this.liftStrokeUp.bind(_assertThisInitialized(_this));
    cov_1yx7tpadr3().s[20]++;
    _this.svgCanvas = React__namespace.createRef();
    return _this;
  }

  var _proto = ReactSketchCanvas.prototype;

  _proto.getSketchingTime = function getSketchingTime() {
    cov_1yx7tpadr3().f[3]++;

    var _ref = (cov_1yx7tpadr3().s[21]++, this.props),
        withTimestamp = _ref.withTimestamp;

    var _ref2 = (cov_1yx7tpadr3().s[22]++, this.state),
        currentPaths = _ref2.currentPaths;

    cov_1yx7tpadr3().s[23]++;
    return new Promise(function (resolve, reject) {
      cov_1yx7tpadr3().f[4]++;
      cov_1yx7tpadr3().s[24]++;

      if (!withTimestamp) {
        cov_1yx7tpadr3().b[0][0]++;
        cov_1yx7tpadr3().s[25]++;
        reject(new Error("Set 'withTimestamp' prop to get sketching time"));
      } else {
        cov_1yx7tpadr3().b[0][1]++;
      }

      cov_1yx7tpadr3().s[26]++;

      try {
        var sketchingTime = (cov_1yx7tpadr3().s[27]++, currentPaths.reduce(function (totalSketchingTime, path) {
          var _ref3, _ref4;

          cov_1yx7tpadr3().f[5]++;
          var startTimestamp = (cov_1yx7tpadr3().s[28]++, (_ref3 = (cov_1yx7tpadr3().b[1][0]++, path.startTimestamp)) != null ? _ref3 : (cov_1yx7tpadr3().b[1][1]++, 0));
          var endTimestamp = (cov_1yx7tpadr3().s[29]++, (_ref4 = (cov_1yx7tpadr3().b[2][0]++, path.endTimestamp)) != null ? _ref4 : (cov_1yx7tpadr3().b[2][1]++, 0));
          cov_1yx7tpadr3().s[30]++;
          return totalSketchingTime + (endTimestamp - startTimestamp);
        }, 0));
        cov_1yx7tpadr3().s[31]++;
        resolve(sketchingTime);
      } catch (e) {
        cov_1yx7tpadr3().s[32]++;
        reject(e);
      }
    });
  };

  _proto.resetCanvas = function resetCanvas() {
    cov_1yx7tpadr3().f[6]++;
    cov_1yx7tpadr3().s[33]++;
    this.setState(_extends({}, this.initialState));
  };

  _proto.liftPathsUp = function liftPathsUp() {
    cov_1yx7tpadr3().f[7]++;

    var _ref5 = (cov_1yx7tpadr3().s[34]++, this.state),
        currentPaths = _ref5.currentPaths;

    var _ref6 = (cov_1yx7tpadr3().s[35]++, this.props),
        onChange = _ref6.onChange;

    cov_1yx7tpadr3().s[36]++;
    onChange(currentPaths);
  };

  _proto.liftStrokeUp = function liftStrokeUp() {
    cov_1yx7tpadr3().f[8]++;

    var _ref7 = (cov_1yx7tpadr3().s[37]++, this.state),
        currentPaths = _ref7.currentPaths;

    var _ref8 = (cov_1yx7tpadr3().s[38]++, this.props),
        onStroke = _ref8.onStroke;

    var lastStroke = (cov_1yx7tpadr3().s[39]++, currentPaths.at(-1));
    cov_1yx7tpadr3().s[40]++;

    if (lastStroke === undefined) {
      cov_1yx7tpadr3().b[3][0]++;
      cov_1yx7tpadr3().s[41]++;
      console.warn('No stroke found!');
      cov_1yx7tpadr3().s[42]++;
      return;
    } else {
      cov_1yx7tpadr3().b[3][1]++;
    }

    cov_1yx7tpadr3().s[43]++;
    onStroke(lastStroke, !lastStroke.drawMode);
  }
  /* Mouse Handlers - Mouse down, move and up */
  ;

  _proto.handlePointerDown = function handlePointerDown(point) {
    cov_1yx7tpadr3().f[9]++;

    var _ref9 = (cov_1yx7tpadr3().s[44]++, this.props),
        strokeColor = _ref9.strokeColor,
        strokeWidth = _ref9.strokeWidth,
        eraserWidth = _ref9.eraserWidth,
        withTimestamp = _ref9.withTimestamp;

    cov_1yx7tpadr3().s[45]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[10]++;
      cov_1yx7tpadr3().s[46]++;
      draft.isDrawing = true;
      cov_1yx7tpadr3().s[47]++;
      draft.undoStack = [];
      var stroke = (cov_1yx7tpadr3().s[48]++, {
        drawMode: draft.drawMode,
        strokeColor: draft.drawMode ? (cov_1yx7tpadr3().b[4][0]++, strokeColor) : (cov_1yx7tpadr3().b[4][1]++, '#000000'),
        strokeWidth: draft.drawMode ? (cov_1yx7tpadr3().b[5][0]++, strokeWidth) : (cov_1yx7tpadr3().b[5][1]++, eraserWidth),
        paths: [point]
      });
      cov_1yx7tpadr3().s[49]++;

      if (withTimestamp) {
        cov_1yx7tpadr3().b[6][0]++;
        cov_1yx7tpadr3().s[50]++;
        stroke = _extends({}, stroke, {
          startTimestamp: Date.now(),
          endTimestamp: 0
        });
      } else {
        cov_1yx7tpadr3().b[6][1]++;
      }

      cov_1yx7tpadr3().s[51]++;
      draft.currentPaths.push(stroke);
    }), this.liftPathsUp);
  };

  _proto.handlePointerMove = function handlePointerMove(point) {
    cov_1yx7tpadr3().f[11]++;

    var _ref10 = (cov_1yx7tpadr3().s[52]++, this.state),
        isDrawing = _ref10.isDrawing;

    cov_1yx7tpadr3().s[53]++;

    if (!isDrawing) {
      cov_1yx7tpadr3().b[7][0]++;
      cov_1yx7tpadr3().s[54]++;
      return;
    } else {
      cov_1yx7tpadr3().b[7][1]++;
    }

    cov_1yx7tpadr3().s[55]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[12]++;
      var currentStroke = (cov_1yx7tpadr3().s[56]++, draft.currentPaths[draft.currentPaths.length - 1]);
      cov_1yx7tpadr3().s[57]++;
      currentStroke.paths.push(point);
    }), this.liftPathsUp);
  };

  _proto.handlePointerUp = function handlePointerUp() {
    var _this2 = this;

    cov_1yx7tpadr3().f[13]++;

    var _ref11 = (cov_1yx7tpadr3().s[58]++, this.props),
        withTimestamp = _ref11.withTimestamp;

    var _ref12 = (cov_1yx7tpadr3().s[59]++, this.state),
        isDrawing = _ref12.isDrawing;

    cov_1yx7tpadr3().s[60]++;

    if (!isDrawing) {
      cov_1yx7tpadr3().b[8][0]++;
      cov_1yx7tpadr3().s[61]++;
      return;
    } else {
      cov_1yx7tpadr3().b[8][1]++;
    }

    cov_1yx7tpadr3().s[62]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[14]++;
      cov_1yx7tpadr3().s[63]++;
      draft.isDrawing = false;
      cov_1yx7tpadr3().s[64]++;

      if (!withTimestamp) {
        cov_1yx7tpadr3().b[9][0]++;
        cov_1yx7tpadr3().s[65]++;
        return;
      } else {
        cov_1yx7tpadr3().b[9][1]++;
      }

      var currentStroke = (cov_1yx7tpadr3().s[66]++, draft.currentPaths.pop());
      cov_1yx7tpadr3().s[67]++;

      if (currentStroke) {
        cov_1yx7tpadr3().b[10][0]++;
        cov_1yx7tpadr3().s[68]++;
        currentStroke = _extends({}, currentStroke, {
          endTimestamp: Date.now()
        });
        cov_1yx7tpadr3().s[69]++;
        draft.currentPaths.push(currentStroke);
      } else {
        cov_1yx7tpadr3().b[10][1]++;
      }
    }), function () {
      cov_1yx7tpadr3().f[15]++;
      cov_1yx7tpadr3().s[70]++;

      _this2.liftPathsUp();

      cov_1yx7tpadr3().s[71]++;

      _this2.liftStrokeUp();
    });
  }
  /* Mouse Handlers ends */

  /* Canvas operations */
  ;

  _proto.eraseMode = function eraseMode(erase) {
    cov_1yx7tpadr3().f[16]++;
    cov_1yx7tpadr3().s[72]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[17]++;
      cov_1yx7tpadr3().s[73]++;
      draft.drawMode = !erase;
    }), this.liftPathsUp);
  };

  _proto.clearCanvas = function clearCanvas() {
    cov_1yx7tpadr3().f[18]++;
    cov_1yx7tpadr3().s[74]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[19]++;
      cov_1yx7tpadr3().s[75]++;
      draft.resetStack = draft.currentPaths;
      cov_1yx7tpadr3().s[76]++;
      draft.currentPaths = [];
    }), this.liftPathsUp);
  };

  _proto.undo = function undo() {
    cov_1yx7tpadr3().f[20]++;

    var _ref13 = (cov_1yx7tpadr3().s[77]++, this.state),
        resetStack = _ref13.resetStack; // If there was a last reset then


    cov_1yx7tpadr3().s[78]++;

    if (resetStack.length !== 0) {
      cov_1yx7tpadr3().b[11][0]++;
      cov_1yx7tpadr3().s[79]++;
      this.setState(immer.produce(function (draft) {
        cov_1yx7tpadr3().f[21]++;
        cov_1yx7tpadr3().s[80]++;
        draft.currentPaths = draft.resetStack;
        cov_1yx7tpadr3().s[81]++;
        draft.resetStack = [];
      }), this.liftPathsUp);
      cov_1yx7tpadr3().s[82]++;
      return;
    } else {
      cov_1yx7tpadr3().b[11][1]++;
    }

    cov_1yx7tpadr3().s[83]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[22]++;
      var lastSketchPath = (cov_1yx7tpadr3().s[84]++, draft.currentPaths.pop());
      cov_1yx7tpadr3().s[85]++;

      if (lastSketchPath) {
        cov_1yx7tpadr3().b[12][0]++;
        cov_1yx7tpadr3().s[86]++;
        draft.undoStack.push(lastSketchPath);
      } else {
        cov_1yx7tpadr3().b[12][1]++;
      }
    }), this.liftPathsUp);
  };

  _proto.redo = function redo() {
    cov_1yx7tpadr3().f[23]++;

    var _ref14 = (cov_1yx7tpadr3().s[87]++, this.state),
        undoStack = _ref14.undoStack; // Nothing to Redo


    cov_1yx7tpadr3().s[88]++;

    if (undoStack.length === 0) {
      cov_1yx7tpadr3().b[13][0]++;
      cov_1yx7tpadr3().s[89]++;
      return;
    } else {
      cov_1yx7tpadr3().b[13][1]++;
    }

    cov_1yx7tpadr3().s[90]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[24]++;
      var lastUndoPath = (cov_1yx7tpadr3().s[91]++, draft.undoStack.pop());
      cov_1yx7tpadr3().s[92]++;

      if (lastUndoPath) {
        cov_1yx7tpadr3().b[14][0]++;
        cov_1yx7tpadr3().s[93]++;
        draft.currentPaths.push(lastUndoPath);
      } else {
        cov_1yx7tpadr3().b[14][1]++;
      }
    }), this.liftPathsUp);
  }
  /* Exporting options */
  // Creates a image from SVG and renders it on canvas, then exports the canvas as image
  ;

  _proto.exportImage = function exportImage(imageType) {
    var _this$svgCanvas$curre;

    cov_1yx7tpadr3().f[25]++;
    var exportImage = (cov_1yx7tpadr3().s[94]++, (_this$svgCanvas$curre = this.svgCanvas.current) == null ? void 0 : _this$svgCanvas$curre.exportImage);
    cov_1yx7tpadr3().s[95]++;

    if (!exportImage) {
      cov_1yx7tpadr3().b[15][0]++;
      cov_1yx7tpadr3().s[96]++;
      throw Error('Export function called before canvas loaded');
    } else {
      cov_1yx7tpadr3().b[15][1]++;
      cov_1yx7tpadr3().s[97]++;
      return exportImage(imageType);
    }
  };

  _proto.exportSvg = function exportSvg() {
    var _this3 = this;

    cov_1yx7tpadr3().f[26]++;
    cov_1yx7tpadr3().s[98]++;
    return new Promise(function (resolve, reject) {
      var _this3$svgCanvas$curr;

      cov_1yx7tpadr3().f[27]++;
      var exportSvg = (cov_1yx7tpadr3().s[99]++, (_this3$svgCanvas$curr = _this3.svgCanvas.current) == null ? void 0 : _this3$svgCanvas$curr.exportSvg);
      cov_1yx7tpadr3().s[100]++;

      if (!exportSvg) {
        cov_1yx7tpadr3().b[16][0]++;
        cov_1yx7tpadr3().s[101]++;
        reject(Error('Export function called before canvas loaded'));
      } else {
        cov_1yx7tpadr3().b[16][1]++;
        cov_1yx7tpadr3().s[102]++;
        exportSvg().then(function (data) {
          cov_1yx7tpadr3().f[28]++;
          cov_1yx7tpadr3().s[103]++;
          resolve(data);
        })["catch"](function (e) {
          cov_1yx7tpadr3().f[29]++;
          cov_1yx7tpadr3().s[104]++;
          reject(e);
        });
      }
    });
  };

  _proto.exportPaths = function exportPaths() {
    cov_1yx7tpadr3().f[30]++;

    var _ref15 = (cov_1yx7tpadr3().s[105]++, this.state),
        currentPaths = _ref15.currentPaths;

    cov_1yx7tpadr3().s[106]++;
    return new Promise(function (resolve, reject) {
      cov_1yx7tpadr3().f[31]++;
      cov_1yx7tpadr3().s[107]++;

      try {
        cov_1yx7tpadr3().s[108]++;
        resolve(currentPaths);
      } catch (e) {
        cov_1yx7tpadr3().s[109]++;
        reject(e);
      }
    });
  };

  _proto.loadPaths = function loadPaths(paths) {
    cov_1yx7tpadr3().f[32]++;
    cov_1yx7tpadr3().s[110]++;
    this.setState(immer.produce(function (draft) {
      cov_1yx7tpadr3().f[33]++;
      cov_1yx7tpadr3().s[111]++;
      draft.currentPaths = draft.currentPaths.concat(paths);
    }), this.liftPathsUp);
  }
  /* Finally!!! Render method */
  ;

  _proto.render = function render() {
    cov_1yx7tpadr3().f[34]++;

    var _ref16 = (cov_1yx7tpadr3().s[112]++, this.props),
        width = _ref16.width,
        height = _ref16.height,
        className = _ref16.className,
        canvasColor = _ref16.canvasColor,
        backgroundImage = _ref16.backgroundImage,
        preserveBackgroundImageAspectRatio = _ref16.preserveBackgroundImageAspectRatio,
        exportWithBackgroundImage = _ref16.exportWithBackgroundImage,
        style = _ref16.style,
        allowOnlyPointerType = _ref16.allowOnlyPointerType;

    var _ref17 = (cov_1yx7tpadr3().s[113]++, this.state),
        currentPaths = _ref17.currentPaths,
        isDrawing = _ref17.isDrawing;

    cov_1yx7tpadr3().s[114]++;
    return React__namespace.createElement(Canvas, {
      ref: this.svgCanvas,
      width: width,
      height: height,
      className: className,
      canvasColor: canvasColor,
      backgroundImage: backgroundImage,
      exportWithBackgroundImage: exportWithBackgroundImage,
      preserveBackgroundImageAspectRatio: preserveBackgroundImageAspectRatio,
      allowOnlyPointerType: allowOnlyPointerType,
      style: style,
      paths: currentPaths,
      isDrawing: isDrawing,
      onPointerDown: this.handlePointerDown,
      onPointerMove: this.handlePointerMove,
      onPointerUp: this.handlePointerUp
    });
  };

  return ReactSketchCanvas;
}((React__namespace.Component));
ReactSketchCanvas.defaultProps = ( cov_1yx7tpadr3().s[1]++, defaultProps);

function cov_gp4mxvf8v() {
  var path = "/home/vinoth/projects/react-sketch-canvas/src/types/canvas.ts";
  var hash = "2be87fac19128abc01bbef968f5632f44d7b92aa";
  var global = new Function("return this")();
  var gcv = "__coverage__";
  var coverageData = {
    path: "/home/vinoth/projects/react-sketch-canvas/src/types/canvas.ts",
    statementMap: {},
    fnMap: {},
    branchMap: {},
    s: {},
    f: {},
    b: {},
    _coverageSchema: "1a1c01bbd47fc00a2c39e90264f33305004495a9",
    hash: "2be87fac19128abc01bbef968f5632f44d7b92aa"
  };
  var coverage = global[gcv] || (global[gcv] = {});

  if (!coverage[path] || coverage[path].hash !== hash) {
    coverage[path] = coverageData;
  }

  var actualCoverage = coverage[path];
  {
    // @ts-ignore
    cov_gp4mxvf8v = function () {
      return actualCoverage;
    };
  }
  return actualCoverage;
}

cov_gp4mxvf8v();

function cov_o19yvvbx() {
  var path = "/home/vinoth/projects/react-sketch-canvas/src/types/index.ts";
  var hash = "f901f2ab2015710050609381f310eb527969a502";
  var global = new Function("return this")();
  var gcv = "__coverage__";
  var coverageData = {
    path: "/home/vinoth/projects/react-sketch-canvas/src/types/index.ts",
    statementMap: {},
    fnMap: {},
    branchMap: {},
    s: {},
    f: {},
    b: {},
    _coverageSchema: "1a1c01bbd47fc00a2c39e90264f33305004495a9",
    hash: "f901f2ab2015710050609381f310eb527969a502"
  };
  var coverage = global[gcv] || (global[gcv] = {});

  if (!coverage[path] || coverage[path].hash !== hash) {
    coverage[path] = coverageData;
  }

  var actualCoverage = coverage[path];
  {
    // @ts-ignore
    cov_o19yvvbx = function () {
      return actualCoverage;
    };
  }
  return actualCoverage;
}

cov_o19yvvbx();

function cov_1vjjcck374() {
  var path = "/home/vinoth/projects/react-sketch-canvas/src/index.tsx";
  var hash = "8a41ff681dd72447491d9a16cbdba8afde945045";
  var global = new Function("return this")();
  var gcv = "__coverage__";
  var coverageData = {
    path: "/home/vinoth/projects/react-sketch-canvas/src/index.tsx",
    statementMap: {},
    fnMap: {},
    branchMap: {},
    s: {},
    f: {},
    b: {},
    _coverageSchema: "1a1c01bbd47fc00a2c39e90264f33305004495a9",
    hash: "8a41ff681dd72447491d9a16cbdba8afde945045"
  };
  var coverage = global[gcv] || (global[gcv] = {});

  if (!coverage[path] || coverage[path].hash !== hash) {
    coverage[path] = coverageData;
  }

  var actualCoverage = coverage[path];
  {
    // @ts-ignore
    cov_1vjjcck374 = function () {
      return actualCoverage;
    };
  }
  return actualCoverage;
}

cov_1vjjcck374();

exports.Canvas = Canvas;
exports.ReactSketchCanvas = ReactSketchCanvas;
//# sourceMappingURL=react-sketch-canvas.cjs.development.js.map
